import java.util.*;
import java.io.File;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.*;
import java.awt.print.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.EmptyBorder;
import javax.help.*;
import java.net.URL;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

import net.sourceforge.nite.search.*;
import net.sourceforge.nite.meta.*;
import net.sourceforge.nite.meta.impl.*;
import net.sourceforge.nite.nom.nomwrite.*;
import net.sourceforge.nite.nom.nomwrite.impl.*;
import net.sourceforge.nite.gui.textviewer.*;
import net.sourceforge.nite.gui.util.*;
import net.sourceforge.nite.gui.mediaviewer.*;
import net.sourceforge.nite.nxt.*;
import net.sourceforge.nite.nstyle.handler.*;
import net.sourceforge.nite.time.*;
import net.sourceforge.nite.util.SearchResultTimeComparator;
import net.sourceforge.nite.nom.NOMException;


/** Jonathan Kilgour 31/3/2004
 *  Segment the AMI meeting data hierarchically by decision. 
 */
public class AMIDecisionPointEditor implements ActionListener, MouseListener, TreeSelectionListener {
    private static final int FIRST=1;
    private static final int LAST=2;
    private boolean topLevelComplete=false;
    JDialog dialog=null;
    JOptionPane optionPane=null;
    JCheckBox external,recap;
    private String hsName = "jhelpset.hs";
    private HelpSet hs=null;
    private HelpBroker hb=null;
    private CSH.DisplayHelpFromSource dh=null;
    private Clock niteclock;
    private Color startcolour = Color.lightGray;
    private Color endcolour = Color.pink;
    private Color ycolour = new Color(150,250,80);
    private String PSTYLENAME = "pinks";
    private String GSTYLENAME = "grays";
    private String YSTYLENAME = "yellows";
    private String DECISIONCODING = "decision";
    private String DECISIONLINKCODING = "decisionlink";
    private String SUMMLINK = "summlink";
    private String EXTERNAL = "external";
    private String RECAP = "recap";
    private Style gstyle;
    private Style pstyle;
    private Style ystyle;
    private StyleContext stylecontext=new StyleContext();
    private NTextArea transcriptionTextArea;
    private NTextElement openangle;
    private NTree ntree;
    NOMWriteCorpus nom;
    NiteMetaData meta;
    private TreeNode changed_treenode=null;
    private TreePath rootpath=null;
    private NTreeNode topRoot=null;
    JInternalFrame iframe, iframe2, iframe4, iframe5;
    NITEMediaPlayer player;
    String corpusname;
    String observationname;
    String annotatorname;
    JFrame frame;
    String exportdir = ".";
    JScrollPane pane;
    JDesktopPane desktop;
    NOMElement currentDecision=null;
    NOMElement lastWord=null; // span reaches from this element ..
    NOMElement newWord=null;  // .. to this element
    NOMElement subDecision=null;    // subsegments: this is the decision ..
    NOMElement subSegment=null;  // .. and this is the element
    List segmentList=null;       // may be useful to store the List of search results.
    List wordList=new ArrayList();  // may be useful to store the List of words
    NOMElement lastDecision=null;   // span reaches from this element ..
    String lastStyle=null;
    private net.sourceforge.nite.search.GUI search=null;
    private final String SEGMENT="segment";
    private final String PUNC="punc";
    private final String TYPE="type";
    private final String SUBSEGMENT="subsegment";
    private final String SUPERSEGMENT="supersegment";
    private final String WORD="w";
    private final String WORDLAYER="words-layer";
    private final String DECISION="decision";
    private final String DECISIONNAME="decisionname";
    private final String DECLINKROLE="decision";
    private final String DECLINK="decisionlink";
    private final String SENTENCE="sentence";
    private final String ABSLINKROLE="abstract";
    private final String ABSROLE="abstractive";
    private final String DA="dact";
    private final String DEC="decisions";
    private final String NAME="name";
    private final String PARTICIPANT="participant";
    private final String DESCRIPTION_POINTER_ROLE="scenario_decision_type";
    private final String DESCRIPTION="other_description";
    private final String DECISION_DESCRIPTION="other_description";
    private final String EXTERNALATT="external";
    private final String RECAPATT="recap";
    private final String START_CODING="code mode";
    private final String STOP_CODING="review mode";
    private final String FINDCODING="find first uncoded element";
    private final String FINDTEXT="Click to find the first segment that is not in a decision";
    private final String SHOW_START="show ";
    private final String SHOW_END="show";
    private final String MOVE_END="move end";
    private final String MOVE_START="move start";
    private final String DELETEDECISION="delete decision";
    private final String JOINDECISIONS="add super-decision";
    private final String JOINDECISIONTEXT="Select more than one contiguous decisions in the 'Decisions' window then click this button to join them";
    private final String DELETEDECISIONTEXT="Select a decision, then click the button to delete it.";
    private final String EDIT_DESCRIPTION="edit";
    private final String STARTSTOPTEXT="change the mode of the segmenter from 'coding' to 'reviewing' or vice versa";
    private final String NEWSEGMENTTEXT="pause the audio at the correct time, select the word before which you want to segment, then click this button";
    JComboBox decisionSelecter=null;
    JTextField descfield=null;
    JTextField startDetail=null;
    JTextField endDetail=null;
    JTextField description=null;
    //    private String[] stylenamelist = { "blue", "green", "darkGray", "orange", "red", "yellow", "pink", "cyan", "magenta", "black" };
    private String[] stylenamelist = { "red", "blue", "green", "pink", "darkGray" };
    private Style[] stylelist = new Style[stylenamelist.length];
    private int headerFontSize=12;
    int decisionNumber=0;
    private HashMap decisionStyles=new HashMap();
    private HashMap numberhash=new HashMap();
    private boolean WAITINGFORCLICK=false; // this defines if we're coding..
    private boolean CONTINUOUSCODING=true; // this defines if we keep right on
    private JButton startstopbut;
    private boolean redrawingDecisions=false;
    private NOMElement startSubseg=null; // set if start the next decision on a subseg
    private String tempdesc=null;
    private final int CUTOFF=500;
    private final int MAXWORDS=5;
    private boolean linenumbers=false;
    private boolean scenario=true;
    private HashMap agent_speakers=new HashMap();
    private NLayer wordLayer;
    private Hashtable decisionBoxes = new Hashtable();
    
    private Engine searchEngine = new Engine();
    private Comparator decisionComparator = new MyDecisionComparator();
    // holds the elements in the default decision description hierarchy
    private Hashtable descriptionToElement = new Hashtable();
    NOMElement lastDec=null;
    String decstylename=null;
    Style decstyle=null;
    
    public AMIDecisionPointEditor(String c, String o, String a, boolean lines) {
	corpusname = c;
	observationname = o;
	annotatorname = a;
	linenumbers=lines;
	
	try {
	    meta = new NiteMetaData(corpusname);
	} catch (NiteMetaException nme) {
	    nme.printStackTrace();
	}

	wordLayer = meta.findLayerWithName(WORDLAYER);

	NElement nell = meta.getElementByName(DECISION);
	if (nell==null) {
	    JOptionPane.showMessageDialog(null, "Your metadata contains no decision segmentation information. Cannot continue.", "Metadata error", JOptionPane.ERROR_MESSAGE);
	    System.exit(1);
	}
	
	if (observationname==null) {
	    ChooseObservation co = new ChooseObservation(meta);
	    observationname=co.popupDialog();
	    if (observationname==null) { System.exit(0); }
	} 


	/* This should go in any calling script like
	 * net.sourceforge.nite.nxt.GUI rather than here. As far as
	 * this program is concerned we can read and write to any
	 * annotator's space 
	if (annotatorname==null) {
	    ChooseAnnotator awin = new ChooseAnnotator(meta);
	    List annlist = new ArrayList();
	    annlist.add(meta.getCodingByName(DECISIONCODING));
	    annotatorname=awin.popupDialog(annlist);
	    if (annotatorname==null) { System.exit(0); }
	} 
	*/
	
	niteclock = new DefaultClock(meta, observationname);
	try {
	    nom = new NOMWriteCorpus(meta);
	    NiteObservation obs = observationWithName(observationname);
	    /** Set up our program-specific list of layers that
	     * are loaded for the annotator */
	    if (annotatorname!=null) {
		//System.out.println("Force annotator: " + annotatorname);
		nom.forceAnnotatorCoding(annotatorname, DECISIONCODING);
		nom.forceAnnotatorCoding(annotatorname, DECISIONLINKCODING);
		//nom.forceAnnotatorCoding(annotatorname, "segs");
	    }
	    nom.loadData(obs);
	    //System.out.println("Finished loading.");
	    search=new net.sourceforge.nite.search.GUI(nom);
	    pstyle = stylecontext.addStyle(PSTYLENAME, null);
	    //StyleConstants.setForeground(pstyle, endcolour);
	    StyleConstants.setBackground(pstyle, endcolour);
	    StyleConstants.setUnderline(pstyle, true);
	    gstyle = stylecontext.addStyle(GSTYLENAME, null);
	    //StyleConstants.setForeground(gstyle, startcolour);
	    StyleConstants.setBackground(gstyle, startcolour);
	    StyleConstants.setUnderline(gstyle, true);

	    //makeDescriptionMap();
	    setupSpeakerMap(observationname);
	    /* New bit: decide whether the observation is a scenario
	     * meeting or not and let that alter the behaviour */
	    scenario=isScenario(observationname);
	    setupInterface(nom);
	    startCoding();
	    NLayer commlay = meta.getLayerByName("words-layer");
	    //System.out.println("Words: " + commlay);
	    focusTranscription();
	} catch (NOMException nex) {
	    nex.printStackTrace();
	}
    }

    // judge whether this is a scenario or non-scenario meeting 
    private boolean isScenario(String observationname) {
	boolean scen = true;
	List reslist=null;
	try {
	    reslist = searchEngine.search(nom, "($m meeting): $m@observation=\"" + observationname + "\"");
	} catch (Throwable e) {
	    e.printStackTrace();
	    return scen;
	}
	if (reslist != null && reslist.size() > 1) {
	    List outerreslist = (List) reslist.get(1);
	    NOMElement meet = (NOMElement) outerreslist.get(0);
	    if (meet==null) { return scen; }
	    String ts = (String)meet.getAttributeComparableValue("type");
	    if (ts==null) { return scen; }
	    if (ts.indexOf("non")>=0) {
		return false;
	    }
	}
	return scen;
    }

    // set up the mapping between speaker and role...
    private void setupSpeakerMap(String obs) {
	List reslist=null;
	//System.out.println("Assigning strings for: " + obs);	
	try {
	    reslist = searchEngine.search(nom, "($m meeting): $m@observation=\"" + obs + "\"");
	} catch (Throwable e) {
	    e.printStackTrace();
	    return;
	}
	if (reslist != null && reslist.size() != 0) {
	    /* remove first (dud) result */
	    List outerreslist = (List) reslist.get(1);
	    NOMElement meet = (NOMElement) outerreslist.get(0);
	    //System.out.println("Found meeting: " + meet.getID());
	}
    }

    // set up some font styles ahead of time.
    private void makeStyles(int fontSize) {
	for (int i = 0; i < stylenamelist.length; i++) {
	    TextStyleHandler stylehandler = new TextStyleHandler();
	    stylehandler.init("", null);
	    stylehandler.setName(stylenamelist[i]);
	    stylehandler.makeNewStyle();
	    // args are style, foreground colour, background colour
	    stylehandler.setStyle( stylehandler.getColours(stylehandler.getStyle(),
				  stylenamelist[i], stylenamelist[i]));
	    
	    StyleConstants.setFontSize(stylehandler.getStyle(), fontSize);
	    StyleConstants.setBold(stylehandler.getStyle(), true);
	    stylelist[i] = stylehandler.getStyle();
	    transcriptionTextArea.addStyle(stylenamelist[i], stylelist[i]);
	}
	// one more for numbers.
	TextStyleHandler stylehandler = new TextStyleHandler();
	stylehandler.init("", null);
	stylehandler.setName("boldblack");
	stylehandler.makeNewStyle();
	// args are style, foreground colour, background colour
	stylehandler.setStyle( stylehandler.getColours(stylehandler.getStyle(),
						       "black", "black"));
	StyleConstants.setFontSize(stylehandler.getStyle(), fontSize);
	StyleConstants.setBold(stylehandler.getStyle(), true);
	transcriptionTextArea.addStyle("boldblack", stylehandler.getStyle());

	stylehandler.init("", null);
	stylehandler.setName(YSTYLENAME);
	stylehandler.makeNewStyle();
	// args are style, foreground colour, background colour
	stylehandler.setStyle(stylehandler.getColours(stylehandler.getStyle(),
						      "blue", "yellow"));
	
	transcriptionTextArea.addStyle(YSTYLENAME, stylehandler.getStyle());
	    
    }
    
    private void setupInterface(NOMWriteCorpus nom) {
	frame = new JFrame("AMI Decision Point Segmenter");
	frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
	WindowListener l = new WindowAdapter() {
		public void windowClosing(WindowEvent e) { exit(); }
	    };
	frame.addWindowListener(l);
	JMenuBar menubar = new JMenuBar();
	JMenu file = new JMenu("File");
	file.add(new OpenObservationAction());
	file.add(new SaveAction());
	file.add(new SaveAsAction());
	file.add(new RedisplayAction());
	file.add(new PrintAction());
	file.add(new ExitAction());
	menubar.add(file);
	/* Make the search menu too! */
	JMenu search = new JMenu("Search");
	search.add(new SearchAction());
	menubar.add(search);

	JMenu help = new JMenu("Help");
	help.add(new HelpAction());
	menubar.add(help);

	frame.setJMenuBar(menubar);


	desktop = new JDesktopPane();

        // NITE expects text styles to be set up in advance.  Make
        // one for representing out of document links.  This just
	// creates the style; it still has to be added to every
        // text area that will need it.
	TextStyleHandler linkstylehandler = new TextStyleHandler();
	linkstylehandler.init("", null);
	linkstylehandler.setName("link");
	linkstylehandler.makeNewStyle();
	linkstylehandler.setStyle(linkstylehandler.getColours(linkstylehandler.getStyle(), "black", "black"));
        StyleConstants.setFontSize(linkstylehandler.getStyle(), 12);
	StyleConstants.setBold(linkstylehandler.getStyle(), false);
	StyleConstants.setItalic(linkstylehandler.getStyle(), true);
        int x = 0;
        int y = 0;

	iframe = new JInternalFrame("Meeting Transcript (left then right-click for new decision)", true, false, true, true);
	iframe.setSize(new Dimension(500, 550));
	iframe.setLocation(new Point(0, 0));
        showTranscription();
	desktop.add(iframe);

	/* DECISION DISPLAY BOX */
	JInternalFrame iframe2 = new JInternalFrame("Decision Details", true, false, true, true);
	iframe2.setSize(new Dimension(890, 115));
	iframe2.setLocation(new Point(0, 550));
	JPanel panel2 = new JPanel();
	addDecisionDetails(panel2);
	iframe2.getContentPane().add(new JScrollPane(panel2));
	iframe2.setVisible(true);
	desktop.add(iframe2);

	/* DECISION LINK BOX */
	JInternalFrame iframe3 =
	    new JInternalFrame("Decision Links", true, false, true, true);
	iframe3.setSize(new Dimension(890, 150));
	iframe3.setLocation(new Point(0, 665));
	JPanel panel3 = new JPanel();
	addDecisionLinks(panel3);
	iframe3.getContentPane().add(new JScrollPane(panel3));
	iframe3.setVisible(true);
	desktop.add(iframe3);

	niteclock.ensureVisible(new Rectangle(500, 50, 0, 0), desktop);

	/* DECISION TREE */
	iframe4 = new JInternalFrame("Decisions", true, false, true, true);
	iframe4.setSize(new Dimension(390, 340));
	iframe4.setLocation(new Point(500, 210));
 	addDecisionPaneContent(iframe4);
	desktop.add(iframe4);

	// Set up the help system
	try {
	    ClassLoader cl = this.getClass().getClassLoader();
	    URL hsURL = HelpSet.findHelpSet(cl, hsName);
	    hs = new HelpSet(null, hsURL);
	    hb = hs.createHelpBroker();
	    dh = new CSH.DisplayHelpFromSource(hb);
	} catch (Exception ee) {
	    System.err.println ("HelpSet "+ hsName + " not found");
	}


	JPanel panel = new JPanel();
	desktop.setSize(new Dimension(1200, 910));
	frame.getContentPane().add(desktop);
	frame.setSize(new Dimension(1200, 910));
	frame.setVisible(true);
	//startCoding(); stopCoding();
    }

    private NITEMediaPlayer addPlayer() {
	// Add a player for the first signal.
	NITEMediaPlayer myPlayer = null;
	for (Iterator it = meta.getSignals().iterator(); it.hasNext();) {
	    NSignal sig = (NSignal) it.next();
	    String filename = meta.getSignalPath() + File.separator
		+ observationname + "."	+ sig.getName()	+ "." + sig.getExtension();
	    System.out.println("Signal file: " + filename);
	    //((DefaultClock)niteclock).showSignal(filename, sig);
	    
	    if (sig.getMediaType() == NSignal.VIDEO_SIGNAL) {
		myPlayer = new NITEVideoPlayer( new File(filename), 
					      (DefaultClock) niteclock);
	    } else if (sig.getMediaType() == NSignal.AUDIO_SIGNAL) {
      		myPlayer = new NITEAudioPlayer( new File(filename),
				    (DefaultClock) niteclock);
		//myPlayer.setSize(new Dimension(390, 130));
	    }
	    myPlayer.setLocation(new Point(500, 0));
	    myPlayer.setSendSynchronization(true);
	    //niteclock.setMasterPlayer(myPlayer);
	    niteclock.registerTimeHandler(myPlayer);
	    break;
	}
	return myPlayer;
    }

    /* Add the text areas and buttons for displaying decision details */
    private void addDecisionDetails(JPanel panel) {
	//panel.setLayout(new GridLayout(3, 1));

	// Set external and recap thingys
	JPanel extpanel = new JPanel();
	extpanel.setBorder(new javax.swing.border.EtchedBorder());
	external = new JCheckBox(EXTERNAL);	
	recap = new JCheckBox(RECAP);
	external.addActionListener(this);
	recap.addActionListener(this);
	extpanel.add(external);
	extpanel.add(recap);
	extpanel.setSize(new Dimension(70, 50));
	extpanel.setLocation(new Point(0, 0));
	panel.add(extpanel);

	// Show details
	JPanel showpanel = new JPanel();
	showpanel.setBorder(new javax.swing.border.EtchedBorder());
	showpanel.setSize(new Dimension(350, 50));
	showpanel.setLocation(new Point(80, 0));
	Dimension longf = new Dimension (300, 20);
	showpanel.setLayout(new GridBagLayout());
	GridBagConstraints c = new GridBagConstraints();
	c.insets = new Insets(2,2,2,2);
	EmptyBorder border = new EmptyBorder( new Insets (0,0,0,5) );
	c.anchor = GridBagConstraints.WEST;

	JLabel label1 = new JLabel("Start: ");
	label1.setBorder(border);
	showpanel.add(label1, c);
	String content = "";
	if (lastWord!=null) {
	    //content = lastWord.getAttribute(PARTICIPANT).getStringValue() + ": ";
	    content = lastWord.getAgentName() + ": ";
	    content += getTextContent(lastWord);
	}
	startDetail = new JTextField(content);
	startDetail.setPreferredSize(longf);
	startDetail.setEditable(false);
	c.gridx=1;
	c.weightx=1.0;
	showpanel.add(startDetail, c);
	c.gridx=2; c.gridy=0;
	c.weightx=0.0;
	JButton but = new JButton(SHOW_START);
	but.addActionListener(this);
	showpanel.add(but, c);

	c.gridx=0; c.gridy=1;
	c.weightx=0.0;
	JLabel label2 = new JLabel("End:");
	label2.setBorder(border);
	showpanel.add(label2, c);
	endDetail = new JTextField("");
	endDetail.setPreferredSize(longf);
	endDetail.setEditable(false);
	c.gridx=1; c.gridy=1;
	c.weightx=1.0;
	showpanel.add(endDetail,c);
	c.gridx=2; c.gridy=1;
	c.weightx=0.0;
	but = new JButton(SHOW_END);
	but.addActionListener(this);
	showpanel.add(but, c);
	c.gridx=0;
	c.gridy=2;
	panel.add(showpanel);

	// delete decision
	JPanel delpanel = new JPanel();
	delpanel.setBorder(new javax.swing.border.EtchedBorder());
	JButton sbut1 = new JButton(DELETEDECISION);
	sbut1.setToolTipText(DELETEDECISIONTEXT);
	sbut1.addActionListener(this);
	delpanel.add(sbut1);
	panel.add(delpanel);
    }

    private void addDecisionLinks(JPanel panel) {
	// Decision links

	List decisionList=null;
	try {
	    decisionList = searchEngine.search(nom, "($s sentence)($d decisions):$d^$s");
	} catch (Throwable e) {
	    e.printStackTrace();
	    System.exit(0);
	}
	if (decisionList == null || decisionList.size() <= 1) {
	    System.err.println("NO DECISION P0INTS IN DATA!");
	    System.exit(0);
	}

        /* remove first (dud) result */
	decisionList.remove(0);

	JPanel dpanel = new JPanel();
	dpanel.setBorder(new javax.swing.border.EtchedBorder());
	dpanel.setSize(new Dimension(600, 100));
	dpanel.setLocation(new Point(0, 60));
	
	JPanel decpanel = new JPanel();
	decpanel.setLayout(new GridLayout(decisionList.size(), 1));
	dpanel.setSize(new Dimension(600, 100));
	dpanel.setLocation(new Point(0, 0));

	for (int i=0; i< decisionList.size(); i++) {
	    List outerreslist = (List) decisionList.get(i);
	    NOMWriteElement sent1 = (NOMWriteElement) outerreslist.get(0);
	    JCheckBox cb = new JCheckBox(sent1.getText());
	    cb.addActionListener(new DecisionCheckboxActionListener(sent1));
	    decisionBoxes.put(sent1.getID(), cb);
	    decpanel.add(cb);
	} 
	dpanel.add(decpanel);
	panel.add(dpanel);
    }

    private class DecisionCheckboxActionListener implements ActionListener {
	NOMElement sentence;

	public DecisionCheckboxActionListener(NOMElement sentence) {
	    super();
	    this.sentence=sentence;
	}

	public void actionPerformed(ActionEvent ae) {
	    if (lastDecision==null) {
		JOptionPane.showInternalMessageDialog(iframe,"Select a decision, then select checkbox", "information", JOptionPane.INFORMATION_MESSAGE);
		return;
	    }
	    try {
		if (((JCheckBox)ae.getSource()).isSelected()) {
		    System.out.println("COMMAND: " + ae.getActionCommand() + "; object:" + ae.getSource());
		    NOMWriteElement nwe = new NOMWriteAnnotation(nom, DECLINK, observationname, (String)null);
		    nwe.addPointer(new NOMWritePointer(nom, DECLINKROLE, nwe, lastDecision));
		    nwe.addPointer(new NOMWritePointer(nom, ABSLINKROLE, nwe, sentence));
		    nwe.addToCorpus();
		} else { // remove any offending element
		    List decisionList = searchEngine.search(nom, "($dl "+DECLINK+")($de "+DECISION+")($s "+SENTENCE+"):id($s)='"+sentence.getID()+"' && id($de)='"+lastDecision.getID()+"' && $dl>$s && $dl>$de");
		    if (decisionList == null || decisionList.size() <= 1) {
			System.err.println("Nothing to remove");
			return;
		    }
		    List reslist = (List)decisionList.get(1);
		    NOMElement linkel=(NOMElement)reslist.get(0);
		    linkel.getParentInFile().deleteChild(linkel);
		}
	    } catch (Throwable ex) {
		ex.printStackTrace();
	    }
	}
    }

    private void showTranscription() {
	if (transcriptionTextArea != null) {
	    niteclock.deregisterTimeHandler((TimeHandler) transcriptionTextArea);
	    if (search!=null) { search.deregisterResultHandler(transcriptionTextArea); }
	}
	transcriptionTextArea = new NTextArea();
	transcriptionTextArea.addMouseListener(this);
	makeStyles(headerFontSize);

	transcriptionTextArea.setClock(niteclock);
	niteclock.registerTimeHandler((TimeHandler) transcriptionTextArea);
	if (search != null) { search.registerResultHandler(transcriptionTextArea); }

	segmentList = null;

	try {
	    segmentList = searchEngine.search(nom, "($a " + SEGMENT + "):!$a@type || $a@type!='" + SUBSEGMENT + "'");
	} catch (Throwable e) {
	    e.printStackTrace();
	    System.exit(0);
	}
	if (segmentList == null || segmentList.size() <= 1) {
	    System.err.println("NO SEGMENTS IN DATA!");
	    System.exit(0);
	}

        /* remove first (dud) result */
	segmentList.remove(0);

        /* sort in time order */
	Collections.sort(segmentList, new SearchResultTimeComparator());
	currentDecision=null;
	for (int i=0; i< segmentList.size(); i++) {
	    List outerreslist = (List) segmentList.get(i);
	    NOMWriteElement outernwe = (NOMWriteElement) outerreslist.get(0);
	    if (i==0 && lastWord==null) { lastWord=outernwe; }
	    if (linenumbers) {
		showSegmentNumber(i+1,transcriptionTextArea,outernwe);
	    }
	    if (hasSegChildren(outernwe)) {
		for (Iterator sit=outernwe.getChildren().iterator(); sit.hasNext(); ) {
		    NOMWriteElement skid=(NOMWriteElement)sit.next();
		    showSegmentInfo(skid,transcriptionTextArea);
		    transcriptionTextArea.addElement(new NTextElement(": ", null,
				      new NOMObjectModelElement(skid)));
		    showSegmentContent(skid,transcriptionTextArea);
		    if (sit.hasNext()) {
			transcriptionTextArea.addElement(new NTextElement("\n   ", null ));
		    } 
		}
	    } else {
		showSegmentInfo(outernwe,transcriptionTextArea);
		transcriptionTextArea.addElement(new NTextElement(": ", null, 
					    new NOMObjectModelElement(outernwe)));
		showSegmentContent(outernwe,transcriptionTextArea);
	    }
	    transcriptionTextArea.addElement(new NTextElement("\n", null ));
	}
	pane = new JScrollPane(transcriptionTextArea);
	iframe.getContentPane().add(pane);
	iframe.setVisible(true);
	//	highlightStart(lastWord);
    }


    private String getDecisionStyle(NOMElement topel) {
	String style=null;
	if (topel==null) { return null; }
	String description=null;
	NOMAttribute desc = topel.getAttribute(DECISION_DESCRIPTION);
	if (desc==null) { 
	    if (scenario) {
		NOMPointer np = topel.getPointerWithRole(DESCRIPTION_POINTER_ROLE);
		if (np==null) { return null; }
		NOMElement npt = np.getToElement();
		if (npt==null) { return null; }
		description = (String)npt.getAttributeComparableValue(NAME);
	    } else {
		return null; 
	    }
	} else {
	    description = desc.getStringValue();
	}
	if (description==null) { return null; }
	if (decisionStyles.get(description)==null) {
	    int index = decisionNumber % stylenamelist.length;
	    style = stylenamelist[index];
	    decisionStyles.put(description, style);
	    decisionNumber++;
	} else {
	    style = (String)decisionStyles.get(description);
	}
	lastStyle=style;
	return style;    
    }

    private String getSegStyle(NOMElement seg) {
	String style=null;
	if (seg.getChildren()==null) { return null; }
	NOMElement wel = (NOMElement)seg.getChildren().get(0);
	if (wel==null) { return null; }
	NOMElement topel = findAncestorNamed(wel, DECISION);
	if (topel==null) { return null; }
	return getDecisionStyle(topel);
    }

     // Show the segment number
    private void showSegmentNumber(int num, NTextArea nta, NOMElement el) {
	String text = Integer.toString(num);
	NTextElement nte = new NTextElement(text+" ", "boldblack", null);
	numberhash.put(el,new Integer(num));
	nta.addElement(nte);
    }

     // Show the speaker name, then a colon. I am choosing to use the
     // name given in the 'participant' attributre rather than the
     // nite agent name.
    private void showSegmentInfo(NOMWriteElement nwe, NTextArea nta) {
	if (nwe == null) {
	    return;
	}
	String text = "";
	NOMAttribute label = nwe.getAttribute(PARTICIPANT);
	if (label != null) {
	    text = label.getStringValue();
	} else {
	    text = nwe.getAgentName();
	}
	String style=getSegStyle(nwe);

	NTextElement nte = new NTextElement(text, style, nwe.getStartTime(), nwe.getEndTime(), new NOMObjectModelElement(nwe));
	nta.addElement(nte);
    }

    private List getElementsWithNameFromPointers(List pointersto, String elname) {
	List retlist = new ArrayList();
	if (pointersto==null || pointersto.size()==0) { return retlist; }
	for (Iterator pit=pointersto.iterator(); pit.hasNext(); ) {
	    NOMPointer np=(NOMPointer)pit.next();
	    NOMElement nel=np.getFromElement();
	    if (nel.getName().equalsIgnoreCase(elname)) {
		retlist.add(nel);
	    }
	}
	return retlist;
    }

    /* show the pcdata in this element and display other children like
       disfluency markers etc */
    private void showSegmentContent(NOMElement nwe, NTextArea nta) {
	if (nwe.getChildren() != null) {
	    for (Iterator kit=nwe.getChildren().iterator(); kit.hasNext(); ) {
		NOMElement kid = (NOMElement)kit.next();
		showSegmentContent(kid, nta);
		if (kid.getName().equals(SEGMENT) && kit.hasNext()) {
		    nta.addElement(new NTextElement("\n    ", null ));
		    showSegmentInfo((NOMWriteElement)kid, nta);
		    nta.addElement(new NTextElement(": ", null, 
				   new NOMObjectModelElement(kid)));
		}
	    }
	} else {
	    NOMElement tt = findAncestorNamed(nwe, DECISION);
	    boolean open=false;
	    boolean close=false;
	    if (tt==null && currentDecision!=null) { close=true; } 
	    else if (tt!=null && currentDecision==null) { open=true; } 
	    else if (tt!=null && tt!=currentDecision) {
		close=true;
		open=true;
	    }
	    if (close) {
		NOMObjectModelElement tome = new NOMObjectModelElement(currentDecision);
		String style = getDecisionStyle(currentDecision);
		transcriptionTextArea.addElement(new NTextElement(" >> ", style, tome));
	    }
	    if (open) {
		NOMObjectModelElement ntome = new NOMObjectModelElement(tt);
		String style = getDecisionStyle(tt);
		transcriptionTextArea.addElement(new NTextElement(" << ", style, ntome));
	    }
	    if (open || close) { currentDecision=tt; }

	    if (nwe.getText()!= null) {
		NOMElement dec=null;
		if (nwe.getName().equals(WORD)) {
		    try {
			NOMElement da = nwe.findAncestorNamed(DA);
			List sl = getElementsWithNameFromPointers(da.getPointersTo(), SUMMLINK);
			if (sl.size()>0) {
			    for (Iterator slit=sl.iterator(); slit.hasNext(); ) { 
				NOMElement linkel=(NOMElement)slit.next();
				NOMPointer np = linkel.getPointerWithRole(ABSROLE);
				dec=np.getToElement().findAncestorNamed(DEC);
				if (dec!=null) { 
				    //System.out.println("DECISION for Word: " + nwe.getText()+"; da: "+da.getID()+": "+sl.size());
				    break; 
				}
			    }
			}
		    } catch (Exception ex) { }
		}

		if (lastDec!=null && dec==null) {
		    decstylename=null;
		    lastDec=null;
		}

		if (dec!=null && dec!=lastDec) {
		    decstylename=YSTYLENAME;
		    //nta.addElement(new NTextElement("\u2022\u2022", null));
		}

		NTextElement nte=new NTextElement(nwe.getText(), decstylename, 
			nwe.getStartTime(), nwe.getEndTime(),
			  new NOMObjectModelElement(nwe));
		nta.addElement(nte);
		wordList.add(nwe);
		if (dec==null &&lastDec!=null) {
		    //nta.addElement(new NTextElement("\u2022\u2022", null));
		}
		lastDec=dec;
		nta.addElement(new NTextElement(" ", null)); 
	    } else {
		String text="";
		if (nwe.getName().equals(SEGMENT)) {
		    text = "[ no content ]";
		} else {
		    text = "[" + nwe.getName();
		    String desc=(String)nwe.getAttributeComparableValue(DESCRIPTION); 
		    if (desc!=null) { text+=": " + desc; }
		    text+="] ";
		    wordList.add(nwe);
		}
		nta.addElement(new NTextElement(text, decstylename, new NOMObjectModelElement(nwe))); 
	    }
	}
    }

    /** same as above but return string */
    private String getTextContent(NOMElement nwe) {
	String ret="";
	if (nwe.getChildren() != null) {
	    for (Iterator kit=nwe.getChildren().iterator(); kit.hasNext(); ) {
		NOMElement kid = (NOMElement)kit.next();
		ret += getTextContent(kid);
	    }
	} else if (nwe.getText()!= null) {         
	    ret += nwe.getText() + " ";
	} else {
	    if (nwe.getName().equals(SEGMENT)) {
		ret = "[ no content ]";
	    } else {
		ret = "[" + nwe.getName();
		String desc=(String)nwe.getAttributeComparableValue(DESCRIPTION); 
		if (desc!=null) { ret+=": " + desc; }
		ret+="] ";
	    }
	}
	return ret;
    }


    // highlight the start of a decision in the appropriate colour
    private void highlightStart(NOMElement start) {
	if (start==null) { return; }
	//System.out.println("Highlight start: " + start.getID());
	if (start.getName().equals(DECISION) || start.getName().equals(SEGMENT)) {
	    if (start.getChildren()!=null) {
		highlightStart((NOMElement)start.getChildren().get(0));
		return;
	    }
	} 
	//System.out.println("Highlight Start: " + start.getID());
	transcriptionTextArea.setHighlighted(NTextArea.USER_HIGHLIGHTS, new NOMObjectModelElement(start), gstyle);
    }

    // highlight the end of a decision in the appropriate colour
    private void highlightEnd(NOMElement end) {
	if (end==null) { return; }
	if (end.getName().equals(DECISION) || end.getName().equals(SEGMENT)) {
	    if (end.getChildren()!=null) {
		highlightEnd((NOMElement)end.getChildren().get(end.getChildren().size()-1));
		return;
	    }
	}

	transcriptionTextArea.setHighlighted(NTextArea.USER_HIGHLIGHTS, new NOMObjectModelElement(end), pstyle);
    }


    // find the number of this or its parent 
    private Integer getNumber(NOMElement ele) {
	if (ele==null) return null;
	Integer n = (Integer)numberhash.get(ele);
	if (n==null) {
	    return getNumber(findAncestorNamed(ele, SEGMENT));
	}
	return n;
    }

    // show the 'external' boolean val
    private void showExternal(NOMElement description) {
	external.setSelected(false);
	try {
	    if (((String)description.getAttributeComparableValue(EXTERNALATT)).equalsIgnoreCase("true")) {
		external.setSelected(true);
	    }
	} catch (Exception ex) { }
    }

    // show the 'recap' boolean val for the given description element
    private void showRecap(NOMElement description) {
	recap.setSelected(false);
	try {
	    if (((String)description.getAttributeComparableValue(RECAPATT)).equalsIgnoreCase("true")) {
		recap.setSelected(true);
	    }
	} catch (Exception ex) { }
    }

    // show the decision links for the given description element
    private void showDecisionLinks(NOMElement description) {
	for (Iterator dit=decisionBoxes.values().iterator(); dit.hasNext(); ) { 
	    JCheckBox dcb = (JCheckBox)dit.next();
	    dcb.setSelected(false);
	}
	try {
	    for (Iterator pit=description.getPointersTo().iterator(); pit.hasNext(); ) {
		NOMPointer p = (NOMPointer)pit.next();
		if (!p.getRole().equalsIgnoreCase(DECLINKROLE)) { continue; }
		NOMElement link = p.getFromElement();
		if (!link.getName().equalsIgnoreCase(DECLINK)) { continue; }
		NOMElement sent = link.getPointerWithRole(ABSLINKROLE).getToElement();
		JCheckBox jcb = (JCheckBox)decisionBoxes.get(sent.getID());
		if (jcb!=null) { jcb.setSelected(true); }
	    }
	} catch (Exception ex) { }
    }


    // set the 'start' text field
    private void showStartDetails(NOMElement start) {
	String content = "";
	startDetail.setText(content);
	//System.out.println("showStartDetails: " + start);
	if (start!=null) {
	    if (start.getName().equals(DECISION)) {
		showStartDetails((NOMElement)start.getChildren().get(0));
	    } else {
		NOMElement seg = findAncestorNamed(start, SEGMENT);
		if (seg!=null) {
		    if (linenumbers) {
			Integer n = getNumber(seg);
			if (n!=null) { content += n.toString() + "  "; }
		    }
		    content+=seg.getAgentName() + ": ";
		}
		content += getTextContent(start);
		NOMElement s = start;
		for (int i=0; i<MAXWORDS; i++) {
		    if (s==null) { break; }
		    s=s.getNextSibling();
		    if (s!=null) {
			content += " " + getTextContent(s);
		    }
		}
		startDetail.setText(content);
	    }
	}
	// this was an unsuccessful attempt to scroll to the left.
	//try { startDetail.scrollRectToVisible(startDetail.modelToView(0)); } 
	//catch (BadLocationException bex) { }
    }

    // set the 'end' text field
    private void showEndDetails(NOMElement end) {
	String content = "";
	endDetail.setText(content);
	if (end!=null) {
	    if (end.getName().equals(DECISION)) {
		showEndDetails((NOMElement)end.getChildren().get(end.getChildren().size()-1));
	    } else {
		NOMElement seg = findAncestorNamed(end, SEGMENT);
		if (seg!=null) {
		    if (linenumbers) {
			Integer n = getNumber(seg);
			if (n!=null) { content += n.toString() + "  "; }
		    }
		    content+=seg.getAgentName() + ": ";
		}
		else { content += end.getAgentName() + ": "; }
		String mcontent = getTextContent(end);
		NOMElement s = end;
		for (int i=0; i<MAXWORDS; i++) {
		    if (s==null) { break; }
		    s=s.getPreviousSibling();
		    if (s!=null) {
			mcontent = getTextContent(s) + " " + mcontent;
		    }
		}
		//System.out.println("MCONTENT: " + mcontent + "; CONTENT: " + content);
		endDetail.setText(content + mcontent);
	    }
	}
	//try { endDetail.scrollRectToVisible(endDetail.modelToView(0)); } 
	//catch (BadLocationException bex) { }
    }

    // called when we're coding and want to proceed to the next decision.
    // we assume that startCoding has set 'newWord' appropriately ( no
    // point in iterating through segments twice)
    private void moveOn() {
	lastWord=newWord;
	newWord=null;
	transcriptionTextArea.clearHighlights(NTextArea.USER_HIGHLIGHTS);
	showStartDetails(lastWord);
	transcriptionTextArea.setHighlighted(NTextArea.SELECTION_HIGHLIGHTS, new NOMObjectModelElement(lastWord));
	//transcriptionTextArea.setHighlighted(NTextArea.USER_HIGHLIGHTS, new NOMObjectModelElement(lastWord), gstyle);
	if (lastWord.getName().equals(SEGMENT)) {
	    lastWord = (NOMElement)lastWord.getChildren().get(0);
	}
	NOMObjectModelElement wome = new NOMObjectModelElement(lastWord);
	Set tes = transcriptionTextArea.getTextElements(wome);
	if (tes!=null && tes.size()>0) {
	    NTextElement wte=(NTextElement)tes.iterator().next();
	    if (openangle!=null) { 
		transcriptionTextArea.redisplayElement(openangle, "");
	    }
	    openangle=new NTextElement(" << ", null );
	    transcriptionTextArea.clearHighlights(NTextArea.SELECTION_HIGHLIGHTS);
	    transcriptionTextArea.insertElement(openangle, wte.getPosition());
	    transcriptionTextArea.setHighlighted(NTextArea.SELECTION_HIGHLIGHTS, openangle);
	}
	try {
	    transcriptionTextArea.getCaret().setDot(((NTextElement)transcriptionTextArea.getHighlightedTextElements(NTextArea.SELECTION_HIGHLIGHTS).first()).getPosition());
	} catch (Exception ex) { }	
	showEndDetails(null);
	WAITINGFORCLICK=true;
    }

    private void showEndDecision(NOMElement decision) {
	if (decision==null) {
	    showEndDetails(null);
	    return;
	}
	List kids = decision.getChildren();
	if (kids.size()>0) {
	    NOMElement end = (NOMElement)kids.get(kids.size()-1);
	    highlightEnd(end);
	    showEndDetails(end);
	}
    }

    private void showStartDecision(NOMElement decision) {
	//System.out.println("Show start " + decision);
	if (decision==null) {
	    showStartDetails(null);
	    return;
	}
	List kids = decision.getChildren();
	if (kids.size()>0) {
	    NOMElement st = (NOMElement)kids.get(0);
	    highlightStart(st);
	    showStartDetails(st);
	}
    }


    // Display details of the decision in the 'decision' box.
    private void showDecision(NOMElement decision) {
	lastDecision=decision;
	transcriptionTextArea.clearHighlights(NTextArea.USER_HIGHLIGHTS);
	showEndDecision(decision);
	showStartDecision(decision);
	showExternal(decision);
	showRecap(decision);
	showDecisionLinks(decision);
	WAITINGFORCLICK=false;
    }

    // return true if the segment has subsegment children. We assume
    // all children will be subsegments...
    private boolean hasSegChildren(NOMElement seg) {
	List kids = seg.getChildren();
	if (kids!=null) {
	    if (((NOMElement)kids.get(0)).getName().equals(SEGMENT)) {
		return true;
	    }
	}
	return false;
    }

    // return true if the segment has subsegment children. We assume
    // all children will be subsegments...
    private NOMElement findSegChildWithoutDecision(NOMElement seg) {
	List kids = seg.getChildren();
	if (kids!=null) {
	    for (Iterator kit=kids.iterator(); kit.hasNext(); ) {
		NOMElement k=(NOMElement)kit.next();
		NOMElement top = findAncestorNamed(k, DECISION);
		if (top==null) { 
		    if (hasSegChildren(k)) {
			NOMElement kid=findSegChildWithoutDecision(k);
			if (kid!=null) { return kid; }
		    } else {
			return k;
		    }
		}
	    }
	}
	return null;
    }

    // start coding from the first word not owned by a decision
    private boolean startCoding() {
	NOMElement seg = null;
	NOMElement startw = null;
	boolean found=false;
	for (Iterator sit=wordList.iterator(); sit.hasNext(); ) {
	    startw = (NOMElement)sit.next();
	    NOMElement top = findAncestorNamed(startw, DECISION);
	    if (top==null) { 
		found=true; 
		break; 
	    }
	}

	if (!found) { 
	    if (!topLevelComplete) {
		topLevelComplete=true;
	    } 
	}

	if (found) {
	    //transcriptionTextArea.setHighlighted(NTextArea.USER_HIGHLIGHTS, new NOMObjectModelElement(startw), gstyle);
	    subDecision=null;
	    newWord=startw; 
	    //moveOn();
	} else {
	    //	    JOptionPane.showMessageDialog(frame, "Decision segmentation complete for this observation", "Information", JOptionPane.INFORMATION_MESSAGE);
	    stopCoding();
	}
	return found;
    }

    // if we fail to find a top level element to code, we can start
    // sub-segmenting at the selected tree element
    private NOMElement findSubCoding() {
	NOMElement ret=null;
	subDecision=null;
	subSegment=null;
	Set sel = ntree.getSelectedTreeNodes();
	if (sel != null && sel.iterator()!=null && sel.iterator().hasNext()) {
	    NTreeNode ntn = (NTreeNode) sel.iterator().next();
	    NOMObjectModelElement el = (NOMObjectModelElement) ntn.getDataElement();
	    if (el!=null) { 
		NOMElement ne = (NOMElement)el.getElement();
		if (ne.getName().equals(DECISION)) {
		    subDecision=ne;
		    for (Iterator git=ne.getChildren().iterator(); git.hasNext(); ) {
			NOMElement seg = (NOMElement)git.next();
			if (!seg.getName().equals(DECISION)) {
			    subSegment=seg;
			    break;
			}			
		    }
		    if (subSegment!=null) {
			ret=subSegment;
			//	JOptionPane.showMessageDialog(frame, "Sub segment Decision " + ne.getAttributeComparableValue(DECISION_DESCRIPTION) + ", from segment " + getTextContent(ret), "Information", JOptionPane.INFORMATION_MESSAGE);
		    } else {
			JOptionPane.showMessageDialog(frame, "Top level and selected decision are both fully segmented.", "Information", JOptionPane.INFORMATION_MESSAGE);
			subDecision=null;
			ret=null;
		    }
		} else {
		    subDecision=findAncestorNamed(ne,DECISION);
		    subSegment=ne;
		}
		ret=ne;
	    }		
	}
	return ret;
    }

    // find the segment following this one
    private NOMElement findNextSegment(NOMElement seg) {
	// remember segmentList is a search return, so list of lists.
	NOMElement ret=null;
	for (Iterator sit=segmentList.iterator(); sit.hasNext(); ) {
	    List outerreslist = (List) sit.next();
	    NOMElement segment = (NOMWriteElement) outerreslist.get(0);
	    if (segment==seg) {
		if (sit.hasNext()) { 
		    List ml = (List) sit.next();
		    ret = (NOMWriteElement) ml.get(0);
		} else {
		    ret=null;
		}
		break; 
	    }
	}
	return ret;
    }

    /**
     * We want to load one observation worth of data; return the
     * observation with the name
     * @param observation.  Choke if there isn't one.  */
    private NiteObservation observationWithName(String observation) {
	boolean found = false;
	NiteObservation returnval = null;
	List obs = meta.getObservations();
	Iterator obs_it = obs.iterator();
	while ((obs_it.hasNext()) && (found == false)) {
	    NiteObservation next = (NiteObservation) obs_it.next();
	    if (observation.equals(next.getShortName()) == true) {
		found = true;
		returnval = next;
	    };
	}
	if (found == false) {
	    System.out.println(
			       "Observation named "
			       + observation
			       + " doesn't exist:  exiting...");
	    System.exit(0);
	}
	return returnval;
    }
    
    /**
     * Called to start the  application.
     * Legal command line arguments are:
     *<ul>
     *<li> -corpus  corpus </li>
     * <li> -observation observation </li>
     * <li> -annotator annotator </li>
     * <li> -line-numbers </li>
     *</ul>
     *
     */
    public static void main(String[] args) {
	String corpus=null;
	String observation=null;
	String annotator=null;
	boolean lines=false;
	
	if (args.length < 2 || args.length > 7) { usage(); }
	for (int i=0; i<args.length; i++) {
	    String flag=args[i];
	    if (flag.equals("-corpus") || flag.equals("-c")) {
		i++; if (i>=args.length) { usage(); }
		corpus=args[i];
	    } else if (flag.equals("-observation") || flag.equals("-o")) {
		i++; if (i>=args.length) { usage(); }
		observation=args[i];
	    } else if (flag.equals("-annotator") || flag.equals("-a")) {
		i++; if (i>=args.length) { usage(); }
		annotator=args[i];
	    } else if (flag.equals("-line-numbers") || flag.equals("-l")) {
		lines=true;
	    } else {
		usage();
	    }
	}
	if (corpus == null) { usage(); }
	
	AMIDecisionPointEditor m = new AMIDecisionPointEditor(corpus, observation, annotator, lines);
    }
    
    private static void usage() {
	System.err.println("Usage: java AMIDecisionPointEditor -c metadata-filename [ -o observation-name ] [ -a annotator ] [ -l ]");
	System.exit(0);
    }

    /* We want to use this to get decision parents so use getParents
       rather than getParentInFile */
    private NOMElement findAncestorNamed(NOMElement nel, String name) {
	if (nel==null) { return null; }
	if (nel.getParents()==null) { return null; }
	List pars = new ArrayList(nel.getParents());
	for (Iterator pit=pars.iterator(); pit.hasNext(); ) {
	    NOMElement par = (NOMElement)pit.next();
	    if (par.getName().equals(name)) { return par; }
	    NOMElement anc=findAncestorNamed(par, name);
	    if (anc!=null) { return anc; }
	}
	return null;
    }

    private boolean isAncestor(NOMElement seg, NOMElement subseg) {
	NOMElement par = subseg.getParentInFile();
	if (par==null) { return false; }
	if (par==seg) { return true; }
	return isAncestor(seg,par);
    }

    /* Find the last descendent of this element recursively that has
       the given name or return null */
    private NOMElement findLastDescendentNamed(NOMElement nel, String name) {
	if (nel.getChildren()==null) { return null; }
	NOMElement lkid = (NOMElement)nel.getChildren().get(nel.getChildren().size()-1);
	if (lkid.getName().equals(name)) { return lkid; }
	NOMElement anc=findLastDescendentNamed(lkid, name);
	if (anc!=null) { return anc; }
	return null;
    }

    /* Find the first descendent of this element recursively that has
       the given name or return null */
    private NOMElement findFirstDescendentNamed(NOMElement nel, String name) {
	if (nel.getChildren()==null) { return null; }
	NOMElement lkid = (NOMElement)nel.getChildren().get(0);
	if (lkid.getName().equals(name)) { return lkid; }
	NOMElement anc=findFirstDescendentNamed(lkid, name);
	if (anc!=null) { return anc; }
	return null;
    }


    // judge whether we're the last word / element in a segment
    private boolean isLastElement(NOMElement endAct, NOMElement word) {
	if (endAct==null || endAct.getChildren()==null || word==null) { 
	    return false; 
	}
	List kids=endAct.getChildren(); 
	for (int i=kids.size()-1; i>=0; i--) {
	    NOMElement kid=(NOMElement)kids.get(i);
	    if (kid==word) {
		return true;
	    }
	    if (kid.getName().equals(WORD)) { return false; }
	}
	return false;
    }

    // move right until we hit a word, grabbing following punctuation
    private NOMElement grabElements(NOMElement endAct, NOMElement word) {
	if (endAct==null || endAct.getChildren()==null || word==null) { 
	    return word; 
	}
	NOMElement lastw=word;
	List kids=endAct.getChildren(); 
	boolean started=false;
	for (Iterator wit=kids.iterator(); wit.hasNext(); ) {
	    NOMElement thisw=(NOMElement)wit.next();
	    if (word==thisw) { started=true; continue; }
	    if (started) {
		// gulp up vocalsounds and punctuation 
		String v = (String)thisw.getAttributeComparableValue(PUNC);
		if (thisw.getName().equals(WORD) && (v==null || !v.equals("true"))) { 
		    break; 
		}
		lastw=thisw;
	    }
	}
	return lastw;
    }


    Set subdecisions; // global to store the subdecisions.

    /* Add a new decision given the start and end segments.  If the user
       clicked on a non-segment to end the decision, that's the third
       argument. 

       NOTE to programmers - some of the messing around here could be
       left out if we used the new-ish addChildOfChildren method in
       NOMElement! */
    private boolean addDecision(NOMElement startSegment, NOMElement endSegment, NOMElement word) {
	NOMElement addsub2=null;
	subdecisions=new LinkedHashSet();

	try {
	    
	    // if we judge the clicked word to be the end of a
	    // segment, then just take the whole containing segment as
	    // the end point

	    //System.out.println("Word: " + word.getID() + "; end seg: " + endSegment.getID());
	    NOMElement oword=word;

	    if (word==null) {
		List kids = endSegment.getChildren();
		word = (NOMElement)kids.get(kids.size()-1);
	    }
	    // if (word!=null && isLastElement(endSegment, word)) { word=null; }
	    if (word!=null) { word=grabElements(endSegment, word); }

	    //System.out.println("Word: " + word.getID() + "; last; " + isLastElement(endSegment, oword));

	    // get a description
	    /*
	    String d = getDescription("");
	    if (d==null || d.length()==0) { return false; }
	    */

	    NOMWriteAnnotation decision = new NOMWriteAnnotation(nom, DECISION, observationname, (String)null);
	    NOMElement topel=null;

	    // add the decision label?
	    /*
	    if (scenario) {
		NOMElement toel = (NOMElement)descriptionToElement.get(d);
		//System.out.println("Element for desc: " + d + " is: " + toel);
		if (toel==null) {
		    ((NOMWriteAnnotation)decision).addAttribute(new NOMWriteAttribute(DECISION_DESCRIPTION, d));
		    NOMElement toel2 = (NOMElement)descriptionToElement.get("other");
		    if (toel2!=null) {
			((NOMWriteAnnotation)decision).addPointer(new NOMWritePointer(nom, DESCRIPTION_POINTER_ROLE, lastDecision, toel2));
		    }
		} else {
		    ((NOMWriteAnnotation)decision).addPointer(new NOMWritePointer(nom, DESCRIPTION_POINTER_ROLE, lastDecision, toel));
		}
	    } else {
		((NOMWriteAnnotation)decision).addAttribute(new NOMWriteAttribute(DECISION_DESCRIPTION, d));
	    }
	    */

	    //decision.addAttribute(new NOMWriteAttribute(DECISION_DESCRIPTION, d));
	    String style = getDecisionStyle(decision);
	    NOMObjectModelElement tome = new NOMObjectModelElement(decision);

	    NOMObjectModelElement wome = new NOMObjectModelElement(word);
	    Set tes = transcriptionTextArea.getTextElements(wome);
	    if (tes!=null && tes.size()>0) {
		NTextElement wte=(NTextElement)tes.iterator().next();
		int pos = wte.getPosition() + wte.getText().length();
		NTextElement ntt=new NTextElement(" >> ", style, tome );
		if (openangle!=null) { 
		    openangle.setStyle(style);
		    openangle.setDataElement(tome);
		    transcriptionTextArea.redisplayElement(openangle," << ");
		    //transcriptionTextArea.redisplayElement(tome);
		    transcriptionTextArea.clearHighlights(NTextArea.SELECTION_HIGHLIGHTS);
		    transcriptionTextArea.clearHighlights(NTextArea.USER_HIGHLIGHTS);
		    transcriptionTextArea.insertElement(ntt, pos);
		}
		openangle=null;
	    }

	    NOMElement eDecision=findAncestorNamed(endSegment,DECISION);

	    // remember segmentList is a search return, so list of lists.
	    // add the in-between segments
	    boolean started=false, stopped=false;
	    int scount=0;
	    NOMElement segment=null;
	    for (Iterator sit=segmentList.iterator(); sit.hasNext(); ) {
		List outerreslist = (List) sit.next();
		segment = (NOMWriteElement) outerreslist.get(0);
		if (segment==startSegment || isAncestor(segment, startSegment)) {
		    started=true; 
		    segment=startSegment;
		}
		if (started && !stopped) {
		    if (segment==endSegment || isAncestor(segment, endSegment)) {
			stopped=true; 
			//segment=endSegment;
		    }
		    if (subDecision!=null) {
			NOMElement topword = (NOMElement)segment.getChildren().get(0);
			if (segment==startSegment) { topword=lastWord; }
			else if (segment==endSegment) { topword=word; }
			NOMElement oldtop = findAncestorNamed(topword, DECISION);
			if (oldtop!=null) { 
			    NOMElement strtword=null;
			    if (segment==startSegment) { strtword=lastWord; }
			    removeWordChildren(oldtop,segment,strtword,word); 
			}
		    }
		    //System.out.println("Adding segment " + segment.getID() + "; stopped: " + stopped + "; endseg = " + endSegment.getID());
		    if (stopped) { continue; }
		    NOMElement fromword=null;
		    if (segment==startSegment) { fromword=lastWord; }
		    addWordChildren(decision,segment, fromword, null);
		    //decision.addChild(segment);
		    scount++;
		} else if (started && stopped) {
		    topel = findAncestorNamed(segment, DECISION);
		    if (topel!=null) { break; }
		}
	    }

	    startSubseg=null;


	    NOMElement fromword=null;
	    if (endSegment==startSegment) { fromword=lastWord; }
	    // add the end segment.
	    if (word!=null) {
		addWordChildren(decision, endSegment, fromword, word);
	    } else { // only add the last element if it's not being subsegmented
		//System.out.println("NULL word!");
		NOMElement oldtop = findAncestorNamed(endSegment, DECISION);
		if (oldtop!=null) { 
		    //System.out.println("Remove: " + segment.getID() + " (" + getTextContent(segment) + "). subDecision: " + subDecision);
		    oldtop.removeChild(endSegment); 
		}
		addWordChildren(decision,endSegment,fromword,null);
	    }
	    

	    // add the new decision to the corpus
	    if (subDecision!=null) {
		// this looks complicated, but we're just finding out
		// what our following sibling should be in the decision tree.
		NOMElement nextword = word.getNextSibling();
		NOMElement nseg=null;
		if (nextword!=null) {
		    nseg = findAncestorNamed(nextword, SEGMENT);
		}
		if (nextword==null || endSegment!=nseg) {
		    nextword=null;
		    nseg = endSegment.getNextSibling();
		    if (nseg!=null) {
			nextword=(NOMElement)nseg.getChildren().get(0);
		    } 
		}
		NOMElement sib = findSibling(subDecision,nextword);
		if (sib!=null) {
		    subDecision.addChildBefore(sib, decision);
		} else {
		    subDecision.addLastChild(decision);
		}
	    } else {
		if (topel==null) { decision.addToCorpus(); } 
		else { decision.addBeforeSibling(topel); }
	    }

	    // add the second subseg into its parent
	    if (addsub2!=null) {
		addsub2.addAfterSibling(decision);
	    }

	    // One more thing! We may have subsumed some subdecisions, so
	    // for each one in turn, add them as our children in the
	    // right place, then delete their children from us.
	    for (Iterator subit=subdecisions.iterator(); subit.hasNext(); ) {
		NOMElement subtop = (NOMElement)subit.next();
		subtop.getParentInFile().removeChild(subtop);
		//System.out.println("Handling subdecisions of " + decision.getID() + ": " + subtop.getID());
		List kl = subtop.findDescendantsInLayer(wordLayer);
		NOMElement firstkid = (NOMElement)kl.get(0);
		decision.addChildBefore(firstkid, subtop);
		//System.out.println("Added subdecision :" + subtop.getID());
		List subkids = new ArrayList(subtop.getChildren());
		for (Iterator skit=subkids.iterator(); skit.hasNext(); ) {
		    NOMElement subkid=(NOMElement)skit.next();
		    try {
			decision.removeChild(subkid);
		    } catch (NOMException nex) {
			// may be some sub-sub-decisions
		    }
		    //System.out.println("Removed child of " + decision.getID() + " :" + subkid.getID());
		}
	    }

	    lastDecision=(NOMElement)decision;
	    redisplayDecisions();

	    // Re-Draw
	    // don't redisplay transcription if we're in a subdecision?
	    //	    if (subDecision!=null) { return true; }

	    if (scount<CUTOFF) {
		//System.out.println("CUTOFF not reached: (" + scount + "). redisplay individual");
		started=false;
		for (Iterator sit=segmentList.iterator(); sit.hasNext(); ) {
		    List outerreslist = (List) sit.next();
		    NOMElement seg = (NOMWriteElement) outerreslist.get(0);
		    updateColour(startSegment, style);
		    if (seg==startSegment || isAncestor(seg, startSegment)) { 
			started=true; 
		    }
		    if (started) {
			NOMAttribute typ = seg.getAttribute(TYPE);
			if (seg==endSegment || isAncestor(seg, endSegment)) {
			    updateColour(endSegment,style);
			} else {
			    if (hasSegChildren(seg)) {
				for (Iterator scit=seg.getChildren().iterator(); scit.hasNext(); ) {
				    updateColour((NOMElement)scit.next(),style);
				}
			    } else {
				updateColour(seg, style);
			    }
			}
			if (seg==endSegment || isAncestor(seg, endSegment)) {
			    break;
			}
		    } 
		}
	    } else {
		//System.out.println("CUTOFF Exceeded: (" + scount + "). redisplay all");
		redisplayTranscription();		
	    }
	    return true;
	} catch (NOMException nex) {
	    nex.printStackTrace();
	    return false;
	}
    }

    private void removeWordChildren(NOMElement top, NOMElement seg) throws NOMException {
	removeWordChildren(top,seg,(NOMElement)null, (NOMElement)null);
    }

    private void removeWordChildren(NOMElement top, NOMElement seg, NOMElement wordfrom,
				 NOMElement wordto) throws NOMException {
	//System.out.println("REMOVE words from decision: " + top + "; seg: " + seg.getID() + "; word: " + wordto);
	if (top==null || seg==null) { return; }
	List words = seg.findDescendantsInLayer(wordLayer);
	//System.out.println("Words: " + words + "; layer: " + meta.getLayerByName(WORDLAYER) + "; layer name: " + WORDLAYER);
	if (words==null) { return; }
	//for (Iterator wit=words.iterator(); wit.hasNext(); ) {
	boolean started=true;
	if (wordfrom!=null) { started=false; }
	for (Iterator wit=seg.getChildren().iterator(); wit.hasNext(); ) {
	    NOMElement nword = (NOMElement) wit.next();
	    if (!started && nword==wordfrom) {
		started=true;
	    }
	    if (started) {
		try {
		    top.removeChild(nword);
		} catch (NOMException nex) {
		    // the seg children won't all necessarily be in this decision!
		}
	    }
	    if (wordto!=null && nword==wordto) {
		break;
	    }
	}
    }

    private void addWordChildren(NOMElement top, NOMElement seg) throws NOMException {
	addWordChildren(top,seg,(NOMElement)null,(NOMElement)null);
    }

    private void addWordChildren(NOMElement top, NOMElement seg, NOMElement wordfrom, NOMElement wordto) throws NOMException {
	//System.out.println("ADD words to decision: " + top + "; seg: " + seg.getID() + "; wordto: " + wordto);
	if (top==null || seg==null) { return; }
	List words = seg.findDescendantsInLayer(meta.getLayerByName(WORDLAYER));
	//System.out.println("Words: " + words + "; layer: " + meta.getLayerByName(WORDLAYER) + "; layer name: " + WORDLAYER);
	if (words==null) { return; }
	boolean started=true;
	if (wordfrom!=null) { started=false; }
	//for (Iterator wit=words.iterator(); wit.hasNext(); ) {
	for (Iterator wit=seg.getChildren().iterator(); wit.hasNext(); ) {
	    NOMElement nword = (NOMElement) wit.next();
	    if (!started && nword==wordfrom) {
		started=true;
	    }
	    if (started) {
		NOMElement ptop = getHighestAncestorDecision(nword);
		if (ptop!=null) {
		    //System.out.println("ADD sub decision: " + ptop.getID());
		    subdecisions.add(ptop);
		}
		top.addChild(nword);
	    }
	    if (wordto!=null && nword==wordto) {
		break;
	    }
	}
    }
    
    /** return the oldest decision ancestor of this element or null if none */
    private NOMElement getHighestAncestorDecision(NOMElement el) {
	if (el==null) { return null; }
	NOMElement p = el.findAncestorNamed(DECISION);
	if (p==null) { return null; }
	NOMElement par = getHighestAncestorDecision(p);
	if (par==null) { return p; }
	return par;
    }

    // find a sibling to add a decision to. Either returns the second
    // argument if it's a direct descendent of the first, or the
    // direct descendent of the first that's an ancestor of the
    // second; or null. got that?
    private NOMElement findSibling(NOMElement top, NOMElement seg) {
	if (seg==null || top==null) { return null; }
	if (seg.getParents()==null) { return null; }
	for (Iterator pit=seg.getParents().iterator(); pit.hasNext(); ) {
	    NOMElement par = (NOMElement)pit.next();
	    if (par==top) { return seg; }
	}
	for (Iterator pit=seg.getParents().iterator(); pit.hasNext(); ) {
	    NOMElement par = (NOMElement)pit.next();
	    NOMElement ret = findSibling(top, par);
	    if (ret!=null) { return ret; }
	}
	return null;
    }

    
    /* 
      This is how we re-colour the decisions, but I had
      to edit NTextArea to allow me to get the text elements for a
      particular object model element; it takes a long time; setStyle
      doesn't redisplay; redisplaying without the text value falls
      over; redisplay with the text values falls over where the text
      of the segment breaks a line.
    */
    private void updateColour (NOMElement segment, String style) {
	NOMObjectModelElement nome = new NOMObjectModelElement(segment);
	Set ntes = transcriptionTextArea.getTextElements(nome); 

	//	System.out.println("Segment: '" + segment.getAttributeComparableValue(PARTICIPANT) + "' has " + ntes.size() + " text elements to be drawn in " + style);
	if (ntes==null) { return; }
	for (Iterator nteit=ntes.iterator(); nteit.hasNext(); ) {
	    NTextElement nte = (NTextElement)nteit.next();
	    String ntstr = nte.getText();
	    if (ntstr.indexOf(" ")<0) {
		nte.setStyle(style);
		transcriptionTextArea.redisplayElement(nte,ntstr);
	    }
	} 
    }


    /* Delete a decision */
    private void deleteDecision(NOMElement decision) {
	try {
	    NOMElement par = decision.getParentInFile();
	    List kds = decision.getChildren();
	    if (kds!=null) {
		for (Iterator kit=kds.iterator(); kit.hasNext(); ) {
		    NOMElement kid = (NOMElement) kit.next();
		    if (par.getName().equals(DECISION) || kid.getName().equals(DECISION)) {
			par.addChildBefore(decision,kid);
		    }
		}
	    }
	    par.deleteChild(decision);
	} catch (NOMException nex) { }
	redisplayDecisions();
	redisplayTranscription();
	boolean remembermode=WAITINGFORCLICK;
	if (!remembermode) { stopCoding(); }
    }


    /** A very simple "exit" action */
    public class ExitAction extends AbstractAction {
	public ExitAction() {
	    super("Exit");
	}
	public void actionPerformed(ActionEvent ev) {
	    exit();
	}
    }

    private void exit() {
	if (checkComplete()) {
	    CheckSave co = new CheckSave(nom);
	    if (search != null) {
		search.savePreferences();
	    }
	    if (!(co.popupDialog() == JOptionPane.CANCEL_OPTION)) {
		System.exit(0);
	    }
	}
    }

    /* Don't think there's a completeness check for decisions - they
     * don't have to span */
    private boolean checkComplete() {
	return true;
	/*
	try {
	    boolean sc = startCoding();
	    if (!sc) { return true; }
	    int ret= JOptionPane.showConfirmDialog(null,"You have not completed coding decisions for this observation. Are you sure you want to stop?", "Incomplete", JOptionPane.YES_NO_OPTION, JOptionPane.PLAIN_MESSAGE);
	    if (ret==JOptionPane.YES_OPTION) { return true; }
	    else { return false; }
	} catch (Throwable th) { return true; }
	*/
    }

    /** A "search" action - pops up a search GUI */
    public class SearchAction extends AbstractAction {
	public SearchAction() {
	    super("Search...");
	}
	public void actionPerformed(ActionEvent ev) {
	    search.popupSearchWindow();
	}
    }

    /** A "help" action - pops up some basic help using JavaHelp */
    public class HelpAction extends AbstractAction {
	public HelpAction() {
	    super("Help...");
	}
	public void actionPerformed(ActionEvent ev) {
	    if (dh!=null) {
		hb.setCurrentView("TOC");
		dh.actionPerformed( ev );
	    }
	}
    }

    
    /** this is to sort decisions which point down to currently untimed
     * words. So we compare two decisions by comparing the times of the
     * segment to which their respective first words belong. */
    class MyDecisionComparator implements Comparator {
	
	public int compare(Object obj, Object obj1) {
	    if (obj==null && obj1==null) { return 0; }
	    else if (obj==null)  { return -1; } 
	    else if (obj1==null)  { return 1; }
	    try {
		NOMElement top1 = (NOMElement) obj;
		NOMElement top2 = (NOMElement) obj1;
		List kids1 = top1.findDescendantsInLayer(wordLayer);
		List kids2 = top2.findDescendantsInLayer(wordLayer);
		//System.out.println("Comparing " + top1.getID() + " (" + kids1 + ") to " + top2.getID() + " (" + kids2 + ")");
		//List kids1 = top1.getChildren();
		//List kids2 = top2.getChildren();
		if (kids1==null || kids1.size()==0)  { return -1; } 
		else if (kids2==null || kids2.size()==0)  { return 1; }
		NOMElement w1 = (NOMElement)kids1.get(0);
		NOMElement w2 = (NOMElement)kids2.get(0);
		if (w1==null)  { return -1; } 
		else if (w2==null)  { return 1; }
		NOMElement seg1 = (NOMElement)w1.findAncestorNamed(SEGMENT);
		NOMElement seg2 = (NOMElement)w2.findAncestorNamed(SEGMENT);
		if (seg1==null)  { return -1; } 
		else if (seg2==null)  { return 1; }
		double s1 = seg1.getStartTime();
		double s2 = seg2.getStartTime();
		return (new Double(s1)).compareTo(new Double(s2));
	    } catch (ClassCastException cce) { // you get strings in search results for the variables!
		System.out.println("Exception Comparing '" + obj + "' to '" + obj1 + "'.");
		return -1;
	    }
	}
   }


    private void stopCoding() {
	//	startstopbut.setText(START_CODING);
	transcriptionTextArea.clearHighlights(NTextArea.SELECTION_HIGHLIGHTS);
	showDecision(null);
	WAITINGFORCLICK=false;
    }

    /** This handles all the button-presses etc for the interface */
    public void actionPerformed(ActionEvent ae) {
	String command = ae.getActionCommand();
	subDecision=null;
	//System.out.println("Action: " + command);
	if (command.equals(FINDCODING)) {
	    //	    startstopbut.setText(STOP_CODING);
	    boolean found = startCoding();
	    if (!found) {
		JOptionPane.showMessageDialog(frame, "Top level decision segmentation complete for this observation", "Information", JOptionPane.INFORMATION_MESSAGE);
	    } else {
		WAITINGFORCLICK=true;
	    }
	    lastDecision=null;
	} else if (command.equals(STOP_CODING)) {
	    stopCoding();
	} else if (command.equals(DELETEDECISION)) {
	    if (lastDecision==null) {
		JOptionPane.showInternalMessageDialog(iframe,"Select a decision, then click button", "information", JOptionPane.INFORMATION_MESSAGE);
		return;
	    }
	    deleteDecision(lastDecision);
	    lastDecision=null;
	} else if (command.equals(SHOW_START)) {
	    if (lastDecision==null) {
		JOptionPane.showInternalMessageDialog(iframe,"Select a decision, then click button", "information", JOptionPane.INFORMATION_MESSAGE);
		return;
	    }
	    transcriptionTextArea.clearHighlights(NTextArea.USER_HIGHLIGHTS);
	    showStartDecision(lastDecision);
	} else if (command.equals(SHOW_END)) {
	    if (lastDecision==null) {
		JOptionPane.showInternalMessageDialog(iframe,"Select a decision, then click button", "information", JOptionPane.INFORMATION_MESSAGE);
		return;
	    }
	    transcriptionTextArea.clearHighlights(NTextArea.USER_HIGHLIGHTS);
	    showEndDecision(lastDecision);
	} else if (command.equals(JOINDECISIONS)) {
	    try { joinDecisions(); }
	    catch (NOMException nex) { nex.printStackTrace(); }
	} else if (command.equals(EDIT_DESCRIPTION)) {
	    if (lastDecision==null) {
		JOptionPane.showInternalMessageDialog(iframe,"Select a decision, then edit its description", "information", JOptionPane.INFORMATION_MESSAGE);
		return;
	    }


	    redisplayDecisions();
	    startCoding();
	    focusTranscription();
	} else if (command.equals(EXTERNAL)) {
	    if (lastDecision==null) {
		JOptionPane.showInternalMessageDialog(iframe,"Select a decision, then select checkbox value", "information", JOptionPane.INFORMATION_MESSAGE);
		return;
	    }
	    try {
		if (external.isSelected()) {
		    lastDecision.setStringAttribute(EXTERNALATT, "true");
		} else {
		    lastDecision.removeAttribute(EXTERNALATT);
		}
	    } catch (Exception ex) {

	    }
	} else if (command.equals(RECAP)) {
	    if (lastDecision==null) {
		JOptionPane.showInternalMessageDialog(iframe,"Select a decision, then select checkbox value", "information", JOptionPane.INFORMATION_MESSAGE);
		return;
	    }
	    try {
		if (recap.isSelected()) {
		    lastDecision.setStringAttribute(RECAPATT, "true");
		} else {
		    lastDecision.removeAttribute(RECAPATT);
		}
	    } catch (Exception ex) {

	    }
	} 
    }

    /* Join together the selected decisions (and anything in-between)
       into a new superdecision */
    private void joinDecisions() throws NOMException {
	Set sel = ntree.getSelectedTreeNodesOrdered();
	if (sel == null || sel.iterator()==null || sel.size()<2 || !sel.iterator().hasNext()) { 
	    JOptionPane.showInternalMessageDialog(iframe,"Select multiple decisions in the 'Decisions' window first!", "information", JOptionPane.INFORMATION_MESSAGE);
	    return;
	}
	List toplist=new ArrayList();
	NOMElement par=null;
	NOMElement first=null; NOMElement prev=null;

	// build up a list of decisions, making some checks as we go.
	for (Iterator trit=sel.iterator(); trit.hasNext(); ) {
	    NTreeNode ntn = (NTreeNode) trit.next();
	    NOMObjectModelElement el = (NOMObjectModelElement) ntn.getDataElement();
	    if (el==null) { continue; }
	    NOMElement ne = (NOMElement)el.getElement();
	    if (par==null) { par=ne.getParentInFile(); first=ne; }
	    else if (ne.getParentInFile()!=par) {
		JOptionPane.showInternalMessageDialog(iframe,"Error: Decisions selcted must all be siblings", "ERROR", JOptionPane.INFORMATION_MESSAGE);
		return;
	    }
	    if (!ne.getName().equals(DECISION)) {
		JOptionPane.showInternalMessageDialog(iframe,"Error: Only decisions may be selcted", "ERROR", JOptionPane.INFORMATION_MESSAGE);
		return;
	    }

	    // make sure any in-between segments are included
	    // made extra-tedious by subsegments.
	    if (prev!=null) {
		NOMElement lastseg = findLastDescendentNamed(prev, SEGMENT);
		NOMElement firstseg = findFirstDescendentNamed(ne, SEGMENT);
		NOMElement startsubseg=null;
		NOMElement endsubseg=null;
	        NOMElement lsup=findAncestorNamed(lastseg,SEGMENT);
		if (lsup!=null) { 
		    startsubseg=(NOMElement)lsup.getChildren().get(lsup.getChildren().size()-1); 
		}
	        NOMElement fsup=findAncestorNamed(firstseg,SEGMENT);
		if (fsup!=null) { endsubseg=(NOMElement)fsup.getChildren().get(0); }
		if (startsubseg!=null && startsubseg==firstseg) { lastseg=null; }
		if (lastseg!=null && firstseg!=null) {
		    // System.out.println("Last of prev: " + lastseg.getID() + "First of next: " + firstseg.getID());
		    boolean started=false;
		    NOMElement segment=null;
		    for (Iterator sit=segmentList.iterator(); sit.hasNext(); ) {
			List outerreslist = (List) sit.next();
			segment = (NOMWriteElement) outerreslist.get(0);
			if (started) {
			    if (segment==firstseg || isAncestor(segment, firstseg)) { 
				break; 
			    }
			    //System.out.println("Adding segment: " + segment.getID());
			    toplist.add(segment);
			} else if (segment==lastseg || isAncestor(segment, lastseg)) {
			    started=true; 
			    if (startsubseg!=null) {
				toplist.add(startsubseg); 
			    }
			}
		    }
		    if (started && endsubseg!=null) { 
			toplist.add(endsubseg); 			
		    }
		}
	    }

	    toplist.add(ne);
	    prev=ne;
	    //System.out.println("Add element " + ne.getID());
	}

	NOMWriteAnnotation decision = new NOMWriteAnnotation(nom, DECISION, observationname, (String)null);
	NOMElement topel=null;
	par.addChildBefore(first,decision);
	// we have a valid list of decisions
	for (Iterator tpit=toplist.iterator(); tpit.hasNext(); ) {
	    NOMElement tel=(NOMElement)tpit.next();
	    if (tel.getName().equals(DECISION)) {
		NOMElement pare=tel.getParentInFile();
		pare.removeChild(tel);
	    }
	    decision.addChild(tel);
	    //System.out.println("Element " + tel.getID());
	}
	redisplayDecisions();
    }

    /* Clear a display element frame ready for redisplay */
    private void clearFrame(JInternalFrame frame) {
	frame.setVisible(false);
	frame.getContentPane().removeAll();
    }

    /** Save the NOM using the parameters set on the interface
     */
    public class SaveAction extends AbstractAction {
	public SaveAction() {
	    super("Save corpus");
	}
	public void actionPerformed(ActionEvent ev) {
	    try {
		// meta.writeMetaData(corpusname);
		nom.serializeCorpusChanged();
	    } catch (Exception e) {
		e.printStackTrace();
	    }
	}
    }

    /** Print text area */
    public class PrintAction extends AbstractAction {
	public PrintAction() {
	    super("Print...");
	}
	public void actionPerformed(ActionEvent ev) {
	    transcriptionTextArea.printTextArea();
	}
    }

    /* Mouse listener implementation */
    public void mouseClicked(MouseEvent e) {
	//	System.out.println("Click");
    }
    public void mouseEntered(MouseEvent e) {

    }
    public void mouseExited(MouseEvent e) {

    }
    public void mousePressed(MouseEvent e) {
	//	System.out.println("Press");
    }
    public void mouseReleased(MouseEvent e) {
	int b = e.getButton();

	// Do nothing if control button is down so we don't clash with media playing!
	String mods = e.getMouseModifiersText(e.getModifiers());
	if (mods.indexOf("Ctrl")>=0) { return; }
	    
	if (b==MouseEvent.BUTTON1) { 
	    System.out.println("Find highlights");
	    List sel = transcriptionTextArea.getHighlightedModelElements(NTextArea.SELECTION_HIGHLIGHTS);
	    System.out.println("Found highlights");
	    if (sel == null || sel.size()==0) {
		return;
	    } 
	    NOMObjectModelElement el = (NOMObjectModelElement) sel.iterator().next();
	    NOMElement source= el.getElement();

	    System.out.println("Found element: " + el.getID());
	    
	    NOMElement segmentel=null;
	    if (source.getName().equals(DECISION)) {
		showDecision(source);		
		return;
	    } else if (source.getName().equals(SEGMENT)) {
		segmentel=source; 
		source=null;
		if (segmentel.getChildren()!=null) {
		    NOMElement kid1 = (NOMElement) segmentel.getChildren().get(0);
		    if (kid1!=null) {
			subDecision=kid1.findAncestorNamed(DECISION);
		    }
		}
	    } else {
		segmentel = source.findAncestorNamed(SEGMENT);
	    }
	    if (segmentel==null) { showDecision(null); return; }
	    //newWord=segmentel;
	    if (source!=null) {
		subDecision=source.findAncestorNamed(DECISION);
		newWord=source;
	    } else {
		newWord=segmentel;
	    }

	    //System.out.println("Left clicked; subDecision = " + subDecision);
	    //	    subSegment=newWord;
	    subSegment=null;
	    startSubseg=null;
	    moveOn();
	} else if (b==MouseEvent.BUTTON3) { // RIGHT Click
	    //System.out.println("RIGHT");
	    NOMObjectModelElement el = (NOMObjectModelElement) transcriptionTextArea.getObjectModelElementAtPoint(e.getPoint());
	    if (el==null) { return; }
	    NOMElement source= el.getElement();
	    //   System.out.println("Right Clicked: " + getTextContent(source));
	    NOMElement segmentel=null;
	    NOMElement topel=null;
	    if (source.getName().equals(SEGMENT)) {
		segmentel=source; 
		source=null;
		if (segmentel.getChildren()!=null) {
		    NOMElement kid1 = (NOMElement) segmentel.getChildren().get(0);
		    if (kid1!=null) {
			source=kid1;
			topel=kid1.findAncestorNamed(DECISION);
		    }
		}
	    } else {
		segmentel = findAncestorNamed(source, SEGMENT);
		topel = findAncestorNamed(source, DECISION);
	    }

	    if (WAITINGFORCLICK) {
		//System.out.println("Right click while waiting; in subdecision: " + subDecision + "; topel=" + topel);
		//NOMElement topel = findAncestorNamed(segmentel, DECISION);
		if ((topel==null && subDecision==null) || (topel==subDecision)) {
		    showEndDetails(segmentel);
		    NOMElement mseg = findAncestorNamed(lastWord, SEGMENT);
		    if (addDecision(mseg, segmentel, source)) {
			transcriptionTextArea.clearHighlights(NTextArea.SELECTION_HIGHLIGHTS);
			transcriptionTextArea.clearHighlights(NTextArea.USER_HIGHLIGHTS);
			//transcriptionTextArea.clearHighlights();
			//if (source!=null) { highlightEnd(source); }
			//else { highlightEnd(segmentel); }
			startCoding();
		    }
		    focusTranscription();
		} else {
		    JOptionPane.showMessageDialog(frame, "You selected an end point that is not within the same decision as the start segment", "Error", JOptionPane.ERROR_MESSAGE);
		    newWord=lastWord;
		    //moveOn();
		    focusTranscription();
		}
	    } 
	}
    }

    private void redisplayDecisions() {
	clearFrame(iframe4);
	addDecisionPaneContent(iframe4);
	focusTranscription();
    }

    private void redisplayTranscription() {
	clearFrame(iframe);
	decisionStyles=new HashMap();
	showTranscription();
    }

    /* display the list of decisions */
    private void addDecisionPaneContent(JInternalFrame frame ) {
	redrawingDecisions=true;

	topRoot = new NTreeNode("Decisions");
	NOMElement nel = nom.getRootWithColour(observationname + "." + DECISIONCODING);
	if (nel==null) {
	    System.out.println("Failed to find decision element");
	} else {
	    List ml = nel.getChildren();
	    if (ml!=null) {
		Collections.sort(ml, decisionComparator);
		
		for (Iterator ti=ml.iterator(); ti.hasNext();) {
		    NOMElement top = (NOMElement)ti.next();
		    displayDecision(topRoot, top);
		}
	    }
	}

	ntree = new NTree(topRoot);
	ntree.addTreeSelectionListener(this);
	ntree.setCellRenderer(new NTreeCellRenderer());
	rootpath=new TreePath(topRoot);
	JScrollPane pane = new JScrollPane(ntree);
	frame.getContentPane().add(pane);
	frame.setVisible(true);
	if (changed_treenode!=null) {
	    // select the previous selection
	    TreePath path = new TreePath(((DefaultTreeModel) ntree.getModel()).getPathToRoot(changed_treenode));
	    //ntree.addSelectionPath(path);
	}
	redrawingDecisions=false;
	iframe.requestFocus();
	//	ntree.visitAllNodesForData();
    }

    /** try to get focus back to the transcription pane */
    private void focusTranscription() {
	try {
	    iframe4.setSelected(false);
	    iframe.setSelected(true);
	} catch (java.beans.PropertyVetoException pve) {
	    
	}
	desktop.setSelectedFrame(iframe);
    }

    private NOMElement findSegmentChild(NOMElement top, int order) {
	NOMElement n=null;
	if (top==null || top.getChildren()==null) { return null; } 
	if (order==FIRST) {
	    n = (NOMElement) top.getChildren().get(0);
	} else {
	    n = (NOMElement) top.getChildren().get(top.getChildren().size()-1);
	}
	if (n.getName().equals(DECISION)) { 
	    return findSegmentChild(n, order);
	} 
	return n;
    }

    private String DescriptionFromElement(NOMElement decision) {
	if (decision==null) { return null; }
	String id = decision.getID();
	return id.substring(id.lastIndexOf(".")+1,id.length());
    }

    /* Display a decision by adding it to the NTree */
    private void displayDecision(NTreeNode parent, NOMElement decision) {
	String text = "decision " + DescriptionFromElement(decision);
	NTreeNode newnode = new NTreeNode(text);
	NOMObjectModelElement nome= new NOMObjectModelElement(decision);
	newnode.setDataElement((ObjectModelElement)nome);
	List kids = decision.getChildren();

	if (kids!=null) {
	    //Collections.sort(kids, decisionComparator);
	String startstring="Start - ";
	String endstring="End - ";
	NTreeNode snode=null;
	NTreeNode enode=null;

	if (kids.size()>0) {
	    NOMElement st = (NOMElement)kids.get(0);
	    NOMElement stseg = st;
	    if (st.getName().equals(DECISION)) { 
		stseg=findSegmentChild(st,FIRST);
		if (stseg==null) { stseg=st; }
	    } 

	    // Display the first element whether in a decision or not
	    if (linenumbers) {
		Integer n = getNumber(stseg);
		if (n!=null) { startstring += n.toString() + "  "; }
	    }
	    //String spar = (String)stseg.getAttributeComparableValue(PARTICIPANT);
	    String spar = stseg.getAgentName();
	    startstring += spar + ": " + getTextContent(stseg);
	    snode = new NTreeNode(startstring);
	    snode.setDataElement(new NOMObjectModelElement(stseg));
	    
	    if (snode!=null) {
		snode.textcolour=startcolour;
		newnode.addNode(snode);
	    }

	    if (st.getName().equals(DECISION)) { 
		displayDecision(newnode, st);
	    } 
	}


	/*
	  Back to the old way where we don't display inbetween elements.
	*/
	for (int i=1; i<kids.size()-1; i++) {
	    NOMElement kd = (NOMElement) kids.get(i);
	    if (kd.getName().equals(DECISION)) { 
		displayDecision(newnode, kd);
	    }
	    /*
	    else {
	    String spar = stseg.getAgentName();
	    //String spar = (String)kd.getAttributeComparableValue(PARTICIPANT);
		String txt = spar + ": " + getTextContent(kd);
		snode = new NTreeNode(txt);
		snode.setDataElement(new NOMObjectModelElement(kd));	    
		newnode.addNode(snode);
	    }
	    */
	}

	if (kids.size()>0) {
	    NOMElement end = (NOMElement)kids.get(kids.size()-1);
	    NOMElement endseg=end;

	    if (end.getName().equals(DECISION)) { 
		endseg=findSegmentChild(end,LAST);
		if (endseg==null) { endseg=end; }
	    } 

	    // Display the last element whether in a decision or not
	    if (linenumbers) {
		Integer n = getNumber(endseg);
		if (n!=null) { endstring += n.toString() + "  "; }
	    }
	    String epar = endseg.getAgentName();
	    //String epar = (String)endseg.getAttributeComparableValue(PARTICIPANT);
	    endstring += epar + ": " + getTextContent(endseg);
	    enode = new NTreeNode(endstring);
	    enode.setDataElement(new NOMObjectModelElement(endseg));

	    if (end.getName().equals(DECISION)) { 
		displayDecision(newnode, end);
	    } 

	}

	if (enode!=null) {
	    enode.textcolour=endcolour;
	    newnode.addNode(enode);
	}
	}

	parent.addNode(newnode);
	if (decision==lastDecision) {
	    changed_treenode=newnode;
	}
    }


    /** highlight the decision on the text area. This is the
     TreeSelectionListener interface implementation */
    public void valueChanged (TreeSelectionEvent tse) {
	if (redrawingDecisions) { return; }
	Set sel = ntree.getSelectedTreeNodes();
	if (sel == null || sel.iterator()==null || !sel.iterator().hasNext()) { return;	}
	NTreeNode ntn = (NTreeNode) sel.iterator().next();
	NOMObjectModelElement el = (NOMObjectModelElement) ntn.getDataElement();
	if (el==null) { return; }
	NOMElement ne = (NOMElement)el.getElement();
	if (ne.getName().equals(DECISION)) {
	    stopCoding();
	    showDecision(ne);
	    //	} else if (ne.getName().equals(SEGMENT)) {
	} else {
	    stopCoding();
	    String command = (String)tse.getNewLeadSelectionPath().toString();
	    if (command.indexOf(", Start")>0) {
		highlightStart(ne);
		showStartDetails(ne);
	    } else if (command.indexOf(", End")>0) {
		highlightEnd(ne);
		showEndDetails(ne);
	    } else {
		highlightEnd(ne);
	    }
	}
    }

    /** Redisplay  */
    public class RedisplayAction extends AbstractAction {
	public RedisplayAction() {
	    super("Redisplay...");
	}

	public void actionPerformed(ActionEvent ev) {
	    redisplayTranscription();
	    if (WAITINGFORCLICK) {
		startCoding();
	    } else {
		showDecision(lastDecision);
	    }
	}
    }

    /** Save the changes to the corpus using the dialogue provided
     */
    public class SaveAsAction extends AbstractAction {
	public SaveAsAction() {
	    super("Save as...");
	}
	
	public void actionPerformed(ActionEvent ev) {
	    CorpusSaveOptions cso = new CorpusSaveOptions(nom);
	}
    }

    /** Change observation but check for changes first */
    public class OpenObservationAction extends AbstractAction {
	public OpenObservationAction() {
	    super("Open...");
	}
	public void actionPerformed(ActionEvent ev) {
	    if (checkComplete()) {
		CheckSave co = new CheckSave(nom); 
		if (!(co.popupDialog()==JOptionPane.CANCEL_OPTION)) {
		    subDecision=null;
		    topLevelComplete=false;
		    ChooseObservation cob = new ChooseObservation(meta);
		    observationname=cob.popupDialog();
		    System.out.println("Opening " + observationname);
		    nom.clearData();
		    NObservation obs = meta.getObservationWithName(observationname);
		    try {
			nom.loadData(obs);
		    } catch (NOMException nex) {
			nex.printStackTrace();
		    }
		    redisplayTranscription();
		    redisplayDecisions();
		    //startCoding();
		    //stopCoding();
		    niteclock.ensureVisible(new Rectangle(500, 0, 0, 0), desktop);
		    //if (player!=null) { player.setVisible(false); desktop.remove(player); }
		    //player=addPlayer();
		    //desktop.add(player);
		}
	    }
	}
    }
}
