import java.util.*;
import java.io.File;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.GridBagLayout;
import javax.swing.border.EmptyBorder;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.*;
import java.awt.print.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.help.*;
import java.net.URL;
import javax.swing.plaf.metal.*;

import net.sourceforge.nite.search.*;
import net.sourceforge.nite.meta.*;
import net.sourceforge.nite.meta.impl.*;
import net.sourceforge.nite.nom.nomwrite.*;
import net.sourceforge.nite.nom.nomwrite.impl.*;
import net.sourceforge.nite.gui.textviewer.*;
import net.sourceforge.nite.gui.util.*;
import net.sourceforge.nite.gui.mediaviewer.*;
import net.sourceforge.nite.nxt.*;
import net.sourceforge.nite.nstyle.handler.*;
import net.sourceforge.nite.time.*;

import net.sourceforge.nite.nom.NOMException;

import java.util.Comparator;
import java.util.Collections;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;

/**

*/

public class AMIExtract implements MouseListener {
    private String hsName = "extractsummhelpset.hs";
    private HelpSet hs=null;
    private HelpBroker hb=null;
    private CSH.DisplayHelpFromSource dh=null;
    private Clock niteclock;
    private Color startcolour = Color.lightGray;
    private Color endcolour = Color.pink;
    private NTextArea transcriptionTextArea, abstractTextArea, decisionsTextArea,
	progressTextArea, problemsTextArea;
    NOMWriteCorpus nom;
    NiteMetaData controlData;
    String annotatorname=null;
    JInternalFrame iframe;
    JInternalFrame iframe2;
    JInternalFrame iframe4;
    NITEMediaPlayer player;
    JProgressBar progressBar;
    String corpusname;
    String observationname;
    JFrame frame;
    String exportdir = ".";
    JScrollPane pane, monitorPane;
    JDesktopPane desktop;
    NOMElement lastSegment=null; // span reaches from this element ..
    NOMElement newSegment=null;  // .. to this element
    List segmentList=null;       // may be useful to store the List of search results.
    String lastStyle=null;
    NOMElement summ=null;
    private net.sourceforge.nite.search.GUI search=null;
    private final String SEGMENT="dact";
    private final String VOCALSOUND="vocalsound";
    private final String TYPE="type";
    private final String EXTRACT_TAG="extsumm";
    private final String WORD="w";
    private final String EL_TO_CODE="extsumm";
    private final String ATT_TO_CODE="null";
    private final String PARTICIPANT="participant";
    private final String DESCRIPTION="description";
    private final String BALES_DESCRIPTION="description";
    private final String EXTRACTCODING = "extsumm";
    private final String LINKCODING = "summlink";
    private final String DACODING = "dialog-act";
    private final String DAAPCODING = "adjacency-pairs";
    private final String ABSTRACT="abstract";
    private final String ACTIONS="actions";
    private final String PROBLEMS="problems";
    private final String DECISIONS="decisions";
    private final String SENTENCE="sentence";
    private final String SUMMLINK="summlink";
    private final String ROLEEXT="extractive";
    private final String ROLEABS="abstractive";
    JComboBox balesSelecter=null;
    JTextField descfield=null;
    JTextField startDetail=null;
    JTextField endDetail=null;
    JTextField description=null;
    private int headerFontSize=12;
    private String summstylename,plainstylename;
    private final int CUTOFF=500;
    private Engine searchEngine = new Engine();
    private LinkedHashMap bhash=null;
    boolean shownmess=false;
    private List abslist=new ArrayList();
    private List declist=new ArrayList();
    private List proglist=new ArrayList();
    private List problist=new ArrayList();

    
    public AMIExtract(String c, String o, String a) {
	corpusname = c;
	observationname = o;
	annotatorname=a;
	
	try {
	    controlData = new NiteMetaData(corpusname);
	} catch (NiteMetaException nme) {
	    nme.printStackTrace();
	}
	
	if (observationname==null) {
	    ChooseObservation co = new ChooseObservation(controlData);
	    observationname=co.popupDialog();
	    if (observationname==null) { System.exit(0); }
	} 

	niteclock = new DefaultClock();
	if (controlData.getCorpusType() == NMetaData.STANDOFF_CORPUS) {
	    System.out.println("This is a standoff corpus: NOM being loaded");
	    try {
		nom = new NOMWriteCorpus(controlData);
		NiteObservation obs = observationWithName(observationname);
		if (annotatorname!=null) {
		    nom.forceAnnotatorCoding(annotatorname, EXTRACTCODING);
		    nom.forceAnnotatorCoding(annotatorname, LINKCODING);
		    nom.preferAnnotatorCoding(annotatorname, DACODING);
		    nom.preferAnnotatorCoding(annotatorname, DAAPCODING);
		}
		nom.loadData(obs);
		System.out.println("Finished loading.");
		search=new net.sourceforge.nite.search.GUI(nom);
		// if there is no extractive summary already,
                // create a new summary element and add to corpus.
		// otherwise, find the existing one
		List summlist = nom.getElementsByName(EL_TO_CODE);
		if  (summlist == null) {
		    summ = new NOMWriteAnnotation(nom, EL_TO_CODE, observationname, (String)null);
		    summ.addToCorpus();
		} else {
		    if (summlist.size() > 1) {
			System.err.println("Found more than one existing extractive summary!");
			System.exit(0);
		    } else {
			summ = (NOMElement) summlist.get(0);
		    }
		};
		setupInterface(nom);
	    } catch (NOMException nex) {
		nex.printStackTrace();
	    }
	} else {
	    System.out.println("This is a standalone or simple corpus: no NOM has been loaded");
	}
    }

    // set up some font styles ahead of time.
    private void makeStyles(int fontSize, NTextArea nta) {
	TextStyleHandler stylehandler = new TextStyleHandler();
	stylehandler.init("", null);
	stylehandler.setName("blue");
	stylehandler.makeNewStyle();
	// args are style, foreground colour, background colour
	stylehandler.setStyle( stylehandler.getColours(stylehandler.getStyle(),
						       "blue", "blue"));
	    
	StyleConstants.setFontSize(stylehandler.getStyle(), fontSize);
	StyleConstants.setBold(stylehandler.getStyle(), true);
	summstylename = "blue"; 
	nta.addStyle("blue", stylehandler.getStyle());

	stylehandler.init("", null);
	stylehandler.setName("black");
	stylehandler.makeNewStyle();
	// args are style, foreground colour, background colour
	stylehandler.setStyle( stylehandler.getColours(stylehandler.getStyle(),
						       "black", "black"));
	    
	StyleConstants.setFontSize(stylehandler.getStyle(), fontSize);
	plainstylename = "black"; 
	nta.addStyle("black", stylehandler.getStyle());
    }

    
    private void setupInterface(NOMWriteCorpus nom) {
	frame = new JFrame("AMI Extractive Summarization Coder");
	frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
	WindowListener l = new WindowAdapter() {
		public void windowClosing(WindowEvent e) { exit(); }
	    };
	frame.addWindowListener(l);
	JMenuBar menubar = new JMenuBar();
	JMenu file = new JMenu("File");
	file.add(new OpenObservationAction());
	file.add(new SaveAction());
	file.add(new SaveAsAction());
	file.add(new RedisplayAction());
	file.add(new PrintAction());
	file.add(new ExitAction());
	menubar.add(file);
	/* Make the search menu too! */
	JMenu search = new JMenu("Search");
	search.add(new SearchAction());
	menubar.add(search);

	JMenu help = new JMenu("Help");
	help.add(new HelpAction());
	menubar.add(help);
	frame.setJMenuBar(menubar);
	desktop = new JDesktopPane();

        int x = 0;
        int y = 0;

	iframe = new JInternalFrame("Dialogue Act Display", true, false, true, true);
	iframe.setSize(new Dimension(500, 650));
	iframe.setLocation(new Point(0, 0));
        showTranscription();
	desktop.add(iframe);

	JInternalFrame aframe = new JInternalFrame("Abstract", true, false, true, true);
	aframe.setSize(new Dimension(500, 170));
	aframe.setLocation(new Point(500, 0));
        abstractTextArea=showAbstract(aframe, ABSTRACT, abslist);
	desktop.add(aframe);

	aframe = new JInternalFrame("Decisions", true, false, true, true);
	aframe.setSize(new Dimension(500, 170));
	aframe.setLocation(new Point(500, 170));
        decisionsTextArea=showAbstract(aframe, DECISIONS, declist);
	desktop.add(aframe);

	aframe = new JInternalFrame("Actions", true, false, true, true);
	aframe.setSize(new Dimension(500, 170));
	aframe.setLocation(new Point(500, 340));
        progressTextArea=showAbstract(aframe, ACTIONS, proglist);
	desktop.add(aframe);

	aframe = new JInternalFrame("Problems", true, false, true, true);
	aframe.setSize(new Dimension(500, 170));
	aframe.setLocation(new Point(500, 510));
        problemsTextArea=showAbstract(aframe, PROBLEMS, problist);
	desktop.add(aframe);

	/* MONITOR FOR CURRENT EXTRACTION RATE */
	JInternalFrame iframe2 =
	    new JInternalFrame("Monitor", true, false, true, true);
	iframe2.setSize(new Dimension(500, 70));
	iframe2.setLocation(new Point(0, 650));
	JProgressBar panel2 = addExtractionMonitor();
	iframe2.getContentPane().add(panel2);
	iframe2.setVisible(true);
	desktop.add(iframe2);


	player = addPlayer();
	desktop.add(player);

	// Set up the help system
	
	try {
	    ClassLoader cl = this.getClass().getClassLoader();
	    URL hsURL = HelpSet.findHelpSet(cl, hsName);
	    hs = new HelpSet(null, hsURL);
	    hb = hs.createHelpBroker();
	    dh = new CSH.DisplayHelpFromSource(hb);
	} catch (Exception ee) {
	    System.err.println ("HelpSet "+ hsName + " not found");
	}

	JPanel panel = new JPanel();
	desktop.setSize(new Dimension(1010, 770));
	frame.getContentPane().add(desktop);
	frame.setSize(new Dimension(1010, 770));
	frame.setVisible(true);
    }


    /** find out how many segments there are in the meeting, and 
	make a progress bar showing the current extraction rate.
    */
    private JProgressBar addExtractionMonitor() {
	// how many segments are there that we can extract?
	List segmentlist;
	try { 
        segmentlist = searchEngine.search(nom, "($s " + SEGMENT + "):");
	} catch (Throwable th) { return null; }
	// how mnay have already been extracted in previous runs?  
	List extractedlist;
	try { 
	   extractedlist = searchEngine.search(nom, "($s " + SEGMENT + ")(exists $e " + EXTRACT_TAG + "): ($e ^ $s)");
	} catch (Throwable th) { return null; }
	// if there really are segments, calculate a current extraction rate
	// because we may be loading a meeting that's been coded before.
	if (segmentlist.size() > 1) {
           progressBar = new JProgressBar(0, segmentlist.size() - 1);
	   System.out.println("There are " + (segmentlist.size() - 1)  + " dialogue acts.");
	   int extracted = 0;
	   if (extractedlist.size() > 1) {
		extracted = extractedlist.size() - 1;
	   };
	   System.out.println(extracted  + " have already been extracted.");
	   progressBar.setValue(extracted);
	   progressBar.setStringPainted(true);
      // bomb out if there are no segments.
	} else {
	    System.out.println("No elements of type " + SEGMENT + " are loaded!");
	    System.exit(0);
	}
	return(progressBar);
    }

    private NITEMediaPlayer addPlayer() {
	// Add a player for the first signal - we know there's only one.
	NITEMediaPlayer myPlayer = null;
	for (Iterator it = controlData.getSignals().iterator(); it.hasNext();) {
	    NSignal sig = (NSignal) it.next();
	    String filename = controlData.getSignalPath() + File.separator
		+ observationname + "."	+ sig.getName()	+ "." + sig.getExtension();
	    System.out.println("Signal file: " + filename);
	    if (sig.getMediaType() == NSignal.VIDEO_SIGNAL) {
		myPlayer = new NITEVideoPlayer( new File(filename), 
					      (DefaultClock) niteclock);
	    } else if (sig.getMediaType() == NSignal.AUDIO_SIGNAL) {
      		myPlayer = new NITEAudioPlayer( new File(filename),
				    (DefaultClock) niteclock);
		myPlayer.setSize(new Dimension(270, 60));
	    }
	    myPlayer.setLocation(new Point(500, 0));
	    myPlayer.setSendSynchronization(true);
	    break;
	}
	return myPlayer;
    }


    private void updateVal (NOMElement el, String stylename) {  
	NOMObjectModelElement nome = new NOMObjectModelElement(el);
	Set ntes = transcriptionTextArea.getTextElements(nome); 

	for (Iterator nteit=ntes.iterator(); nteit.hasNext(); ) {
	    NTextElement nte = (NTextElement)nteit.next();
	    nte.setStyle(stylename);
	    String ntstr = nte.getText();
	    //System.out.println("about to redisplay: " + el.getID());
	    transcriptionTextArea.redisplayElement(nome,ntstr,ntstr);
	    //transcriptionTextArea.setHighlighted(nome, MetalLookAndFeel.getTextHighlightColor());
	    transcriptionTextArea.setHighlighted(NTextArea.USER_HIGHLIGHTS, nome);
	    //System.out.println("done with redisplay: " + el.getID());
	}
    }

    private void updateAbsVal (NTextArea nta, NOMObjectModelElement nome, String stylename) {  
	Set ntes = nta.getTextElements(nome); 
	if (ntes==null) { 
	    System.out.println("No results for " + nome.getID() + " in Area: " + nta);
	    return; 
	} 

	for (Iterator nteit=ntes.iterator(); nteit.hasNext(); ) {
	    NTextElement nte = (NTextElement)nteit.next();
	    //nte.setStyle(stylename);
	    nta.setHighlighted(NTextArea.USER_HIGHLIGHTS,nte);
	    //String ntstr = nte.getText();
	    //System.out.println("about to redisplay: " + nome.getID() + ": " + ntstr);
	    //nta.redisplayElement(nome,ntstr,ntstr);
	    //System.out.println("done with redisplay: " + nome.getID());
	}
    }

    private void removeElement(NOMElement nel, String val) {
	if (val.equals(ABSTRACT)) { abslist.remove(nel); }
	else if (val.equals(ACTIONS)) { proglist.remove(nel); }
	else if (val.equals(PROBLEMS)) { problist.remove(nel); }
	else if (val.equals(DECISIONS)) { declist.remove(nel); }
    }

    private void addElement(NOMElement nel, String val) {
	if (val.equals(ABSTRACT)) { abslist.add(nel); }
	else if (val.equals(ACTIONS)) { proglist.add(nel); }
	else if (val.equals(PROBLEMS)) { problist.add(nel); }
	else if (val.equals(DECISIONS)) { declist.add(nel); }
    }

    private List getList(String val) {
	if (val.equals(ABSTRACT)) { return abslist; }
	else if (val.equals(ACTIONS)) { return proglist; }
	else if (val.equals(PROBLEMS)) { return problist; }
	else if (val.equals(DECISIONS)) { return declist; }
	return new ArrayList();
    }

    /* add / remove a link between extractive and abstractive summaries */
    private void doLink(NOMElement dact, NOMElement absel, String lname, NTextArea display) {
	try {
        List absels=getList(lname);
	if (absels.contains(absel)) {
	    //System.out.println("List " + lname + " contains item");
	    updateAbsVal(display,new NOMObjectModelElement(absel),plainstylename);
	    absels.remove(absel);
	    List ps = dact.getPointersTo();
	    if (ps==null) { return; }
	    for (Iterator pit=ps.iterator(); pit.hasNext(); ) {
		NOMElement summlink = ((NOMPointer)pit.next()).getFromElement();
		NOMPointer pabs = summlink.getPointerWithRole(ROLEABS);
		if (pabs.getToElement()==absel) {
		    summlink.getParentInFile().deleteChild(summlink);
		}
	    }
	} else {
	    updateAbsVal(display,new NOMObjectModelElement(absel),summstylename);
	    absels.add(absel);
	    NOMWriteElement nwe = new NOMWriteAnnotation(nom, SUMMLINK, observationname, (String)null);
	    nwe.addPointer(new NOMWritePointer(nom, ROLEEXT, nwe, dact));
	    nwe.addPointer(new NOMWritePointer(nom, ROLEABS, nwe, absel));
	    nwe.addToCorpus();
	}
	} catch (NOMException nex) { }
    }

    /* add / remove an element to / from the extractive summary */
    private void doCoding(NOMObjectModelElement nome, List absels) {
	NOMElement nel=nome.getElement();
	if (!nel.getName().equals(SEGMENT)) {
	    JOptionPane.showMessageDialog(frame, "Left clicking toggles selection of the dialogue act for the summary", "Information", JOptionPane.INFORMATION_MESSAGE);
	    return;
	} 
	
	// we have a dialogueact - check there's no summary that's
	// it's parent
	try {
	    if (summ != findAncestorNamed(nel, EL_TO_CODE)) {
		//it's not in the summary, add it, update progress
		//bar, and redisplay the act header
		summ.addChild(nel);
		if (absels!=null) {
		    for (Iterator ait=absels.iterator(); ait.hasNext(); ) {
			NOMObjectModelElement anode = (NOMObjectModelElement)ait.next();
			NOMElement abst = anode.getElement();
			NOMWriteElement nwe = new NOMWriteAnnotation(nom, SUMMLINK, observationname, (String)null);
			nwe.addPointer(new NOMWritePointer(nom, ROLEEXT, nwe, nel));
			nwe.addPointer(new NOMWritePointer(nom, ROLEABS, nwe, abst));
			nwe.addToCorpus();
		    }
		}

		progressBar.setValue(progressBar.getValue() + 1);
		//System.out.println("adding to summary: " + nel.getID());
		updateVal(nel,summstylename);
	    } else {
		// it's in the summary, remove it, update progress
		// bar, and redisplay the act header
		List ps = nel.getPointersTo();
		if (ps!=null) {
		    for (Iterator pit=ps.iterator(); pit.hasNext(); ) {
			NOMPointer np = (NOMPointer)pit.next();
			NOMElement ne = np.getFromElement();
			//System.out.println("Removing " + ne.getName() + " " + ne.getID());
			ne.getParentInFile().deleteChild(ne);
		    }
		}
		summ.removeChild(nel);
		progressBar.setValue(progressBar.getValue() - 1);
		//System.out.println("removing from summary: " + nel.getID());
		updateVal(nel,plainstylename);
		clearSelections();
	    }
	} catch (NOMException nex) {
	    nex.printStackTrace();
	}
    }


    private void showTranscription() {

	if (transcriptionTextArea != null) {
	    niteclock.deregisterTimeHandler((TimeHandler) transcriptionTextArea);
	    if (search!=null) { search.deregisterResultHandler(transcriptionTextArea); }
	}
	transcriptionTextArea = new NTextArea();
	transcriptionTextArea.addMouseListener(this);
	makeStyles(headerFontSize, transcriptionTextArea);

	transcriptionTextArea.setClock(niteclock);
	niteclock.registerTimeHandler((TimeHandler) transcriptionTextArea);
	if (search != null) { search.registerResultHandler(transcriptionTextArea); }
	//transcriptionTextArea.addKeyListener(new MyKeys());

	List reslist = null;

	try {
	    reslist = searchEngine.search(nom, "($a " + SEGMENT + ")");
	} catch (Throwable e) {
	    e.printStackTrace();
	    System.exit(0);
	}
	/*if (reslist == null || reslist.size() == 1) NULL DOESN'T MATCH SOMEHOW */
	if (reslist.size() == 0 || reslist.size() == 1) {
	    System.err.println("NO ELEMENTS OF TYPE '" + SEGMENT + "' IN DATA!");
	    System.exit(0);
	}
        /* remove first (dud) result */
	reslist.remove(0);
        /* sort in time order */
	segmentList = orderElementsByTime(reslist);
	segmentList = reslist;
	for (int i=0; i< segmentList.size(); i++) {
	    List outerreslist = (List) segmentList.get(i);
	    NOMWriteElement outernwe = (NOMWriteElement) outerreslist.get(0);
	    if (i==0 && lastSegment==null) { lastSegment=outernwe; }
	    String stylename = plainstylename;
	    if (summ == findAncestorNamed(outernwe, EL_TO_CODE)) {
		stylename = summstylename;
	    }
	    showSegmentInfo(outernwe,transcriptionTextArea, stylename);
            showSegmentContent(outernwe,transcriptionTextArea, plainstylename, outernwe);
	    transcriptionTextArea.addElement(new NTextElement("\n", null ));
	}
	pane = new JScrollPane(transcriptionTextArea);
	iframe.getContentPane().add(pane);
	iframe.setVisible(true);
    }

    /** Display one of four text area for the abstractive summary */
    private NTextArea showAbstract(JInternalFrame jif, String srch, List ls) {
	NTextArea abs = new NTextArea();
	abs.addMouseListener(new MyMouseListener(abs, srch));
	makeStyles(headerFontSize, abs);

	abs.setClock(niteclock);
	niteclock.registerTimeHandler((TimeHandler) abs);
	if (search != null) { search.registerResultHandler(abs); }

	List reslist = null;

	try {
	    reslist = searchEngine.search(nom, "($a " + srch + ")");
	} catch (Throwable e) {
	    e.printStackTrace();
	    System.exit(0);
	}

	if (reslist.size() == 0 || reslist.size() == 1) {
	    System.err.println("NO ABSTRACTIVE SUMMARY: YOU NEED TO HAVE AN ABSTRACTIVE SUMMARY BEFORE USING THIS TOOL!");
	    System.exit(0);
	}
        /* remove first (dud) result */
	reslist.remove(0);
	List outerreslist = (List) reslist.get(0);
	NOMWriteElement abel = (NOMWriteElement) outerreslist.get(0);
	showSentenceInfo(abel, abs);
	pane = new JScrollPane(abs);
	jif.getContentPane().add(pane);
	jif.setVisible(true);
	return abs;
    }

    /* Order a list of elements by their start times */
    private List orderElementsByTime(List l1) {
	Collections.sort(l1, new MyTimeComparator());
	return l1;
    };

    /* Order a list of elements by their start times */
    private List orderSimpleElementsByTime(List l1) {
	Collections.sort(l1, new MySimpleTimeComparator());
	return l1;
    };


    private void showSentenceInfo(NOMElement nwe, NTextArea nta) {
	if (nwe == null || nwe.getChildren()==null) { return; }
	for (Iterator kit=nwe.getChildren().iterator(); kit.hasNext(); ) {
	    NOMElement kid = (NOMElement)kit.next();
	    NOMObjectModelElement nome = new NOMObjectModelElement(kid);
	    nta.addElement(new NTextElement("\u2219 ", null, nome ));
	    NTextElement nte1 = new NTextElement(kid.getText(), null, nome);
	    nta.addElement(nte1);
	    nta.addElement(new NTextElement("\n", null ));
	}
    }


    // Show the speaker name, then a colon. I am choosing to use the
    // name given in the 'participant' attributre rather than the
    // nite agent name.  Don't show dialogue act coding information.
    // if the dialogue act is currently in the summary, make it in
    // summstyle on the screen; otherwise, null style.
    private void showSegmentInfo(NOMWriteElement nwe, NTextArea nta, String stylename) {
	if (nwe == null) {
	    return;
	}
	String text = nwe.getAgentName();
	//NOMAttribute label = nwe.getAttribute(PARTICIPANT);
	text += ": ";
	NTextElement nte1 = new NTextElement(text, stylename, nwe.getStartTime(), nwe.getEndTime(), new NOMObjectModelElement(nwe));
	nta.addElement(nte1);
    }
	

    /* show the pcdata in this element - making the display tied to the containing segment */
    /* try what happens if don't tie to containing segment - do we get around bug? */
    private void showSegmentContent(NOMElement nwe, NTextArea nta, String stylename, NOMElement segment) {
	if (nwe.getChildren() != null) {
	    for (Iterator kit=nwe.getChildren().iterator(); kit.hasNext(); ) {
		NOMElement kid = (NOMElement)kit.next();
		showSegmentContent(kid, nta, stylename, segment);
	    }
	} else if (nwe.getText()!= null) {         
	    //nta.addElement(new NTextElement(nwe.getText(), stylename,  new NOMObjectModelElement(segment)));
	    //nta.addElement(new NTextElement(" ", stylename,  new NOMObjectModelElement(segment))); 
	    nta.addElement(new NTextElement(nwe.getText(), stylename, null));
	    nta.addElement(new NTextElement(" ", stylename, null)); 
	} else {
	    String text="";
	    if (nwe.getName().equals(SEGMENT)) {
		text = "[ no matched content ]";
	    } else if (nwe.getName().equals(VOCALSOUND)) {
		text = "[";
		String desc=(String)nwe.getAttributeComparableValue(TYPE);
		if (desc!=null) { text+=desc; }
		else { text += nwe.getName(); }
		text+="] ";
	    } else {
		text = "[" + nwe.getName();
		String desc=(String)nwe.getAttributeComparableValue(DESCRIPTION);
		if (desc!=null) { text+=": " + desc; }
		text+="] ";
	    }
	    nta.addElement(new NTextElement(text, null, null)); 
	    
	}
    }

    /** same as above but return string */
    private String getTextContent(NOMElement nwe) {
	String ret="";
	if (nwe.getChildren() != null) {
	    for (Iterator kit=nwe.getChildren().iterator(); kit.hasNext(); ) {
		NOMElement kid = (NOMElement)kit.next();
		ret += getTextContent(kid);
	    }
	} else if (nwe.getText()!= null) {         
	    ret += nwe.getText() + " ";
	} else {
	    if (nwe.getName().equals(VOCALSOUND)) {
		ret += nwe.getAttributeComparableValue(TYPE) + " ";
	    } else { 
		ret += "[" + (String)nwe.getName() + "]"; 
	    }
	}
	return ret;
    }


    /* We want tio use this to get out of file parents so use getParents
       rather than getParentInFile */
    private NOMElement findAncestorNamed(NOMElement nel, String name) {
	if (nel.getParents()==null) { return null; }
	for (Iterator pit=nel.getParents().iterator(); pit.hasNext(); ) {
	    NOMElement par = (NOMElement)pit.next();
	    if (par.getName().equals(name)) { return par; }
	    NOMElement anc=findAncestorNamed(par, name);
	    if (anc!=null) { return anc; }
	}
	return null;
    }

    /**
     * We want to load one observation worth of data; return the
     * observation with the name
     * @param observation.  Choke if there isn't one.  */
    private NiteObservation observationWithName(String observation) {
	boolean found = false;
	NiteObservation returnval = null;
	List obs = controlData.getObservations();
	Iterator obs_it = obs.iterator();
	while ((obs_it.hasNext()) && (found == false)) {
	    NiteObservation next = (NiteObservation) obs_it.next();
	    if (observation.equals(next.getShortName()) == true) {
		found = true;
		returnval = next;
	    };
	}
	if (found == false) {
	    System.out.println(
			       "Observation named "
			       + observation
			       + " doesn't exist:  exiting...");
	    System.exit(0);
	}
	return returnval;
    }
    
    /**
     * Called to start the  application.
     * Legal command line arguments are:
     *<ul>
     *<li> -corpus  corpus </li>
     * <li> -observation observation </li>
     *</ul>
     *
     */
    public static void main(String[] args) {
	String corpus=null;
	String observation=null;
	String annotator=null;
	
	if (args.length < 2 || args.length > 6) { usage(); }
	for (int i=0; i<args.length; i++) {
	    String flag=args[i];
	    if (flag.equals("-corpus") || flag.equals("-c")) {
		i++; if (i>=args.length) { usage(); }
		corpus=args[i];
	    } else if (flag.equals("-observation") || flag.equals("-o")) {
			i++; if (i>=args.length) { usage(); }
			observation=args[i];
	    } else if (flag.equals("-annotator") || flag.equals("-a")) {
			i++; if (i>=args.length) { usage(); }
			annotator=args[i];
		} else {
		usage();
	    }
	}
	if (corpus == null) { usage(); }
	
	AMIExtract m = new AMIExtract(corpus, observation, annotator);
    }
    
    private static void usage() {
	System.err.println("Usage: java AMIExtract -c metadata-filename -o observation-name");
	System.exit(0);
    }

    /** A very simple "exit" action */
    public class ExitAction extends AbstractAction {
	public ExitAction() {
	    super("Exit");
	}
	public void actionPerformed(ActionEvent ev) {
	    exit();
	}
    }

    private void exit() {
	    CheckSave co = new CheckSave(nom);
	    if (search != null) {
		search.savePreferences();
	    }
	    if (!(co.popupDialog() == JOptionPane.CANCEL_OPTION)) {
		System.exit(0);
	    }
    }


    /** A "search" action - pops up a search GUI */
    public class SearchAction extends AbstractAction {
	public SearchAction() {
	    super("Search...");
	}
	public void actionPerformed(ActionEvent ev) {
	    search.popupSearchWindow();
	}
    }

    /** A "help" action - pops up some basic help using JavaHelp */
    public class HelpAction extends AbstractAction {
	public HelpAction() {
	    super("Help...");
	}
	public void actionPerformed(ActionEvent ev) {
	    if (dh!=null) {
		hb.setCurrentView("TOC");
		dh.actionPerformed( ev );
	    }
	}
    }

   class MyTimeComparator implements Comparator {

	public int compare(Object obj, Object obj1) {
	    if (obj==null && obj1==null) { return 0; }
	    else if (obj==null)  { return -1; } 
	    else if (obj1==null)  { return 1; }
	    try {
		// these are search results so it's a list of elements and we just know
		// to choose the first result
		List l1 = (List)obj;
		List l2 = (List)obj1;
		NOMElement nelement1 = (NOMElement) l1.get(0);
		NOMElement nelement2 = (NOMElement) l2.get(0);
		double s1 = nelement1.getStartTime();
		double s2 = nelement2.getStartTime();
		return (new Double(s1)).compareTo(new Double(s2));
	    } catch (ClassCastException cce) { // you get strings in search results for the variables!
		//	System.out.println("Exception Comparing '" + obj + "' to '" + obj1 + "'.");
		return -1;
	    }
	}
   }

    /* This is the same as above except we're not dealing with search
       results so there's less faff.*/
    class MySimpleTimeComparator implements Comparator {

	public int compare(Object obj, Object obj1) {
	    //	    System.out.println("COMPARE: " + obj + " to: " + obj1);
	    if (obj==null && obj1==null) { return 0; }
	    else if (obj==null)  { return -1; } 
	    else if (obj1==null)  { return 1; }
	    try {
		NOMElement nelement1 = ((NOMObjectModelElement) obj).getElement();
		NOMElement nelement2 = ((NOMObjectModelElement) obj1).getElement();
		double s1 = nelement1.getStartTime();
		double s2 = nelement2.getStartTime();
		/*
		System.out.println("COMPARE: " + (new Double(s1)).toString() +
				   "To: " + (new Double(s2)).toString());
		*/
		return (new Double(s1)).compareTo(new Double(s2));
	    } catch (ClassCastException cce) { // you get strings in search results for the variables!
		return -1;
	    }
	}
   }

    /* Clear a display element frame ready for redisplay */
    private void clearFrame(JInternalFrame frame) {
	frame.setVisible(false);
	frame.getContentPane().removeAll();
    }

    /** Save the NOM using the parameters set on the interface
     */
    public class SaveAction extends AbstractAction {
	public SaveAction() {
	    super("Save corpus");
	}
	public void actionPerformed(ActionEvent ev) {
	    try {
		// controlData.writeMetaData(corpusname);
		nom.serializeCorpusChanged();
	    } catch (Exception e) {
		e.printStackTrace();
	    }
	}
    }

    /** Print text area */
    public class PrintAction extends AbstractAction {
	public PrintAction() {
	    super("Print...");
	}
	public void actionPerformed(ActionEvent ev) {
	    transcriptionTextArea.printTextArea();
	}
    }


    private void redisplayTranscription() {
	clearFrame(iframe);
	showTranscription();
    }


    /** Redisplay  */
    public class RedisplayAction extends AbstractAction {
	public RedisplayAction() {
	    super("Redisplay...");
	}

	public void actionPerformed(ActionEvent ev) {
	    redisplayTranscription();
	}
    }

    /** Save the changes to the corpus using the dialogue provided
     */
    public class SaveAsAction extends AbstractAction {
	public SaveAsAction() {
	    super("Save as...");
	}
	
	public void actionPerformed(ActionEvent ev) {
	    CorpusSaveOptions cso = new CorpusSaveOptions(nom);
	}
    }

    /** Change observation but check for changes first */
    public class OpenObservationAction extends AbstractAction {
	public OpenObservationAction() {
	    super("Open...");
	}
	public void actionPerformed(ActionEvent ev) {
	    CheckSave co = new CheckSave(nom); 
	    if (!(co.popupDialog()==JOptionPane.CANCEL_OPTION)) {
		ChooseObservation cob = new ChooseObservation(controlData);
		observationname=cob.popupDialog();
		System.out.println("Opening " + observationname);
		nom.clearData();
		NObservation obs = controlData.getObservationWithName(observationname);
		try {
		    nom.loadData(obs);
		} catch (NOMException nex) {
		    nex.printStackTrace();
		}
		redisplayTranscription();
		if (player!=null) { player.setVisible(false); desktop.remove(player); }
		player=addPlayer();
		desktop.add(player);
	    }
	}
    }

    /* Mouse listener implementation for transcription window - we use
     * a different one for the other four abstractive summary windows */
    public void mouseClicked(MouseEvent e) {
	//	System.out.println("Click");
    }
    public void mouseEntered(MouseEvent e) {

    }
    public void mouseExited(MouseEvent e) {

    }
    public void mousePressed(MouseEvent e) {
	//	System.out.println("Press");
    }
    public void mouseReleased(MouseEvent e) {
	int b = e.getButton();

	// Do nothing if shift is on so we don't clash with media playing!
	String mods = e.getMouseModifiersText(e.getModifiers());
	if (mods.indexOf("Ctrl")>=0) { return; }

	if (b==MouseEvent.BUTTON1) { 
	    clearSelections();
	    
	    //System.out.println("Cleared selections. Abslist size=" + abslist.size());
	    Set sel = transcriptionTextArea.getSelectedElements();
	    if (sel!=null) {
		transcriptionTextArea.clearHighlights(NTextArea.USER_HIGHLIGHTS);
		NOMObjectModelElement nome = (NOMObjectModelElement) sel.iterator().next();
		NOMElement nel = nome.getElement();
		blueSelections(nel);
	    }
	} else if (b==MouseEvent.BUTTON3) { 
	    Set sel = transcriptionTextArea.getSelectedElements();
	    if (sel == null || sel.size()==0) {
		JOptionPane.showMessageDialog(frame, "To select/deselect a dialogue act for inclusion in the summary, select an act by left-clicking on it, and then right-click.", "Information", JOptionPane.INFORMATION_MESSAGE);
	    return;
	    } 
	    NOMObjectModelElement nome = (NOMObjectModelElement) sel.iterator().next();
	    doCoding(nome, (List)null);    
	}

    }
    /* End of mouse listener implementation for transcription window */

    /* Clear all selections on all NTextAreas */
    private void clearSelections() {
	//System.out.println("Clear selections");
	//abstractTextArea.clearHighlights();
	clearList(abslist, abstractTextArea);
	abslist.clear();
	//decisionsTextArea.clearHighlights();
	clearList(declist, decisionsTextArea);
	declist.clear();
	//progressTextArea.clearHighlights();
	clearList(proglist, progressTextArea);
	proglist.clear();
	//problemsTextArea.clearHighlights();
	clearList(problist, problemsTextArea);
	problist.clear();
    }

    /* Clear all dark bits in abstractive summaries */
    private void clearList(List al, NTextArea nta) {
	if (al==null) { return; }
	for (Iterator lit=al.iterator(); lit.hasNext(); ) {
	    NOMElement nel = (NOMElement)lit.next();
	    updateAbsVal(nta,new NOMObjectModelElement(nel),plainstylename);
	}
	nta.clearHighlights(NTextArea.USER_HIGHLIGHTS);
	nta.clearHighlights(NTextArea.SELECTION_HIGHLIGHTS);
	//al=new ArrayList();
    }

    /* Make all abstractive elements that share a summary link with
     * this element in the extractive summary blue */
    private void blueSelections(NOMElement nel) {
	if (nel==null || nel.getPointersTo()==null) { return; }
	for (Iterator pit=nel.getPointersTo().iterator(); pit.hasNext(); ) {
	    NOMElement summlink = ((NOMPointer)pit.next()).getFromElement();
	    if (summlink.getName()!=SUMMLINK) { continue; }
	    NOMPointer abs = summlink.getPointerWithRole(ROLEABS);
	    if (abs==null) { continue; }
	    NOMElement abel = abs.getToElement();
	    NOMElement abpar = abel.getParentInFile();
	    NTextArea mta = abstractTextArea;
	    if (abpar.getName().equals(DECISIONS)) { mta=decisionsTextArea; declist.add(abel); }
	    else if (abpar.getName().equals(ABSTRACT)) { mta=abstractTextArea; abslist.add(abel); }
	    else if (abpar.getName().equals(PROBLEMS)) { mta=problemsTextArea; problist.add(abel); }
	    else if (abpar.getName().equals(ACTIONS)) { mta=progressTextArea; proglist.add(abel); }
	    updateAbsVal(mta,new NOMObjectModelElement(abel),summstylename);
	}
    }

    /* handle the abstractive summary NTextAreas */
    public class MyMouseListener implements MouseListener {
	private NTextArea nta;
	private String listname;

	public MyMouseListener(NTextArea nta, String lname) {
	    this.nta=nta;
	    this.listname=lname;
	}

	public void mouseClicked(MouseEvent e) { }
	public void mouseEntered(MouseEvent e) { }
	public void mouseExited(MouseEvent e) { }
	public void mousePressed(MouseEvent e) { }
	public void mouseReleased(MouseEvent e) {
	    int b = e.getButton();
	    // Do nothing if shift is on so we don't clash with media playing!
	    String mods = e.getMouseModifiersText(e.getModifiers());
	    if (mods.indexOf("Ctrl")>=0) { return; }
	    
	    if (b==MouseEvent.BUTTON3) { 
		Set sel = nta.getSelectedElements();
		if (sel == null || sel.size()==0) {
		    JOptionPane.showMessageDialog(frame, "To select/deselect a sentence from the abstract summary for linking with the dialogue act, select by left-clicking on it, and then right-click.", "Information", JOptionPane.INFORMATION_MESSAGE);
		    return;
		} 

		Set tsel = transcriptionTextArea.getSelectedElements();
		if (tsel == null || tsel.size()==0) {
		    JOptionPane.showMessageDialog(frame, "Select a dialogue act in the left frame first.", "Information", JOptionPane.INFORMATION_MESSAGE);
		    return;
		} 

		NOMObjectModelElement nomel = (NOMObjectModelElement) sel.iterator().next();
		NOMElement nel= nomel.getElement();

		NOMObjectModelElement dnomel = (NOMObjectModelElement) tsel.iterator().next();
		NOMElement dnel= dnomel.getElement();

		if (summ != findAncestorNamed(dnel, EL_TO_CODE)) {
		    JOptionPane.showMessageDialog(frame, "Select a dialogue act that's in the extractive summary first.", "Information", JOptionPane.INFORMATION_MESSAGE);
		    return;		    
		}
		
		doLink(dnel, nel, listname, nta);
	    }
	}

    }

}

